
'@param OR_init_cfgID Tool configuration ID, see the possible configurations in the table below
'@param OR_init_fbCh Fieldbus channel: 1-4
'
'cfgID                 Primary       Secondary
'-------------------------------------------------------------------
'101   -        -      RG2FT         -
'      -        -      RGx           -
'      -        -      VG10/VGC10    -
'      -        -      Gecko         -
'      -        -      TFG           -
'      -        -      SG            -
'      -        -      SD            -
'      -        HEX    -             -
'102   -        HEX    RGx           -
'      -        HEX    VG10/VGC10    -
'      -        HEX    Gecko         -
'      -        HEX    TFG           -
'      -        HEX    SG            -
'      -        HEX    SD            -
'103   -        -      RGx           VG10/VGC10
'      -        -      RGx           Gecko
'      -        -      RGx           RGx
'      -        -      VG10/VGC10    RGx
'      -        -      VG10/VGC10    Gecko
'      -        -      VG10/VGC10    VG10/VGC10
'      -        -      TFG           RGx
'      -        -      TFG           Gecko
'      -        -      TFG           VG10/VGC10
'      -        -      TFG           TFG  
'      -        -      SG            VG10/VGC10
'      -        -      SG            RGx       
'      -        -      SG            TFG             
'      -        -      SG            Gecko 
'      -        -      SD            VG10/VGC10
'      -        -      SD            RGx       
'      -        -      SD            TFG             
'      -        -      SD            Gecko      
'      -        -      SD            SD     
'104   EYES		-	   -			 -
'	   EYES     -      RG2FT         -
'      EYES     -      RGx           -
'      EYES     -      VG10/VGC10    -
'      EYES     -      Gecko         -
'      EYES     -      TFG           -
'      EYES     -      SG            -
'      EYES     -      SD            -
'      EYES     -      RGx           VG10/VGC10
'      EYES     -      RGx           Gecko
'      EYES     -      RGx           RGx
'      EYES     -      VG10/VGC10    RGx
'      EYES     -      VG10/VGC10    Gecko
'      EYES     -      VG10/VGC10    VG10/VGC10
'      EYES     -      TFG           RGx
'      EYES     -      TFG           Gecko
'      EYES     -      TFG           VG10/VGC10
'      EYES     -      TFG           TFG  
'      EYES     -      SG            VG10/VGC10
'      EYES     -      SG            RGx       
'      EYES     -      SG            TFG             
'      EYES     -      SG            Gecko             
'      EYES     -      SD            VG10/VGC10
'      EYES     -      SD            RGx       
'      EYES     -      SD            TFG             
'      EYES     -      SD            Gecko      
'      EYES     -      SD            SD  
'105   EYES     HEX    -             -
'      EYES     HEX    RGx           -
'      EYES     HEX    VG10/VGC10    -
'      EYES     HEX    Gecko         -
'      EYES     HEX    TFG           -
'      EYES     HEX    SG            -
'      EYES     HEX    SD            -
  
'OR_init_fbCH -> 1 if Channel 1 is used'
'OR_init_fbCH -> 2 if Channel 2 is used'
'OR_init_fbCH -> 3 if Channel 3 is used'
'OR_init_fbCH -> 4 if Channel 4 is used'


UsrProc OR_init(OR_init_cfgID AS INTEGER, OR_init_fbCh AS INTEGER )
  'Select the correct bit offsert according to tool configuration'
  SWITCH OR_init_cfgID
    CASE 101
      OR_EYESrOffset = 0 
      OR_EYESwOffset = 0 
      OR_HEXrOffset = 0
      OR_HEXwOffset = 0
      OR_primR_bitOffset = 0
      OR_primW_bitOffset = 0
      OR_secR_bitOffset = 0
      OR_secW_bitOffset = 0
    BREAK 
  
    CASE 102
      OR_HEXrOffset = 0
      OR_HEXwOffset = 0
      OR_primR_bitOffset = 192
      OR_primW_bitOffset = 128
      OR_secR_bitOffset = 192
      OR_secW_bitOffset = 128
    BREAK 

    CASE 103
      OR_primR_bitOffset = 0
      OR_primW_bitOffset = 0
      OR_secR_bitOffset = 128
      OR_secW_bitOffset = 128
    BREAK

    CASE 104
      OR_EYESrOffset = 0 
      OR_EYESwOffset = 0
      OR_primR_bitOffset = 192
      OR_primW_bitOffset = 192
      OR_secR_bitOffset = 320
      OR_secW_bitOffset = 320
    BREAK 
  
    CASE 105
      OR_HEXrOffset = 192
      OR_HEXwOffset = 192
      OR_EYESrOffset = 0 
      OR_EYESwOffset = 0 
      OR_primR_bitOffset = 384
      OR_primW_bitOffset = 320
    BREAK 

  ENDS
  
  'Select Fieldbus (Ethernet/IP) channel bit offset'
  SWITCH OR_init_fbCh
    CASE 1
      OR_FieldBUS_SB = 161
    BREAK 
    CASE 2
      OR_FieldBUS_SB = 673
    BREAK 
    CASE 3
      OR_FieldBUS_SB = 1185
    BREAK 
    CASE 4
      OR_FieldBUS_SB = 1697
    BREAK 
  ENDS
EndProc



'FUNCTION: Move out gecko pads
'@param OR_Gecko_padOut_inst Gecko device instance: 1 = single or primary, 2 = secondary in dual configuration
'@param OR_Gecko_padOut_wait 0 = don't wait for pad movement, 1 = wait until pad reach the designated position
UsrProc OR_Gecko_padOut(OR_Gecko_padOut_inst AS INTEGER, OR_Gecko_padOut_wait AS INTEGER)
	DIM OR_Gecko_padOut_oW AS INTEGER = 0
	DIM OR_Gecko_padOut_oR AS INTEGER = 0
	
	IF OR_Gecko_padOut_inst = 1
		OR_Gecko_padOut_oW = OR_primW_bitOffset
		OR_Gecko_padOut_oR = OR_primR_bitOffset
	ELSE
		OR_Gecko_padOut_oW = OR_secW_bitOffset
		OR_Gecko_padOut_oR = OR_secR_bitOffset
	ENDIF
	
	SETM O[2 + OR_Gecko_padOut_oW + OR_FieldBUS_SB - 1],  0 'Reset pad in bit
	SETM O[1 + OR_Gecko_padOut_oW + OR_FieldBUS_SB - 1],  1 'Set pad out bit
	STIMER 0.1
	SETM O[1 + OR_Gecko_padOut_oW + OR_FieldBUS_SB - 1],  0 'Reset pad out bit after some time

	IF  OR_Gecko_padOut_wait
		WAITI I[19 + OR_Gecko_padOut_oR + OR_FieldBUS_SB - 1]
	ENDIF

EndProc



'FUNCTION: Move in gecko pads
'@param OR_Gecko_padIn_inst Gecko device instance: 1 = single or primary, 2 = secondary in dual configuration
'@param OR_Gecko_padIn_wait 0 = don't wait for pad movement, 1 = wait until pad reach the designated position
UsrProc OR_Gecko_padIn(OR_Gecko_padIn_inst AS INTEGER, OR_Gecko_padIn_wait AS INTEGER)
	DIM OR_Gecko_padIn_oW AS INTEGER = 0
	DIM OR_Gecko_padIn_oR AS INTEGER = 0
	
	IF OR_Gecko_padIn_inst = 1
		OR_Gecko_padIn_oW = OR_primW_bitOffset
		OR_Gecko_padIn_oR = OR_primR_bitOffset
	ELSE
		OR_Gecko_padIn_oW = OR_secW_bitOffset
		OR_Gecko_padIn_oR = OR_secR_bitOffset
	ENDIF
	
	SETM O[1 + OR_Gecko_padIn_oW + OR_FieldBUS_SB - 1],  0 'Reset pad out bit
	SETM O[2 + OR_Gecko_padIn_oW + OR_FieldBUS_SB - 1],  1 'Set pad in  bit
	STIMER 0.1
	SETM O[2 + OR_Gecko_padIn_oW + OR_FieldBUS_SB - 1],  0 'Reset pad in bit after some time

	IF  OR_Gecko_padIn_wait
		WAITJ I[19 + OR_Gecko_padIn_oR + OR_FieldBUS_SB - 1]
	ENDIF

EndProc



'FUNCTION: Get preload force
'@param OR_Gecko_getF_inst Gecko device instance: 1 = single or primary, 2 = secondary in dual configuration
'@ret preload force in N
UsrProc OR_Gecko_getF( OR_Gecko_getF_inst AS INTEGER ) AS INTEGER
	DIM OR_Gecko_getF_a AS INTEGER = 0 'address
	DIM OR_Gecko_getF_r AS INTEGER = 0 'return value

	'Set bit address
	OR_Gecko_getF_a = 49

	'Set offset according primary (single) or secondary
	IF OR_Gecko_getF_inst = 1
		OR_Gecko_getF_a = OR_Gecko_getF_a + OR_primR_bitOffset
	ELSE
		OR_Gecko_getF_a = OR_Gecko_getF_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_Gecko_getF_r = OR_getI16(OR_Gecko_getF_a)

	OR_Gecko_getF_r = OR_Gecko_getF_r / 100 'get N from 1/100N

RetProc OR_Gecko_getF = OR_Gecko_getF_r
EndProc



'FUNCTION: Get ultrasonic sensor data
'@param OR_Gecko_getUS_inst Gecko device instance: 1 = single or primary, 2 = secondary in dual configuration
'@ret Part distance in mm
UsrProc OR_Gecko_getUS( OR_Gecko_getUS_inst AS INTEGER ) AS INTEGER
	DIM OR_Gecko_getUS_a AS INTEGER = 0 'address
	DIM OR_Gecko_getUS_r AS INTEGER = 0 'return value

	'Set bit address
	OR_Gecko_getUS_a = 65

	'Set offset according primary (single) or secondary
	IF OR_Gecko_getUS_inst = 1
		OR_Gecko_getUS_a = OR_Gecko_getUS_a + OR_primR_bitOffset
	ELSE
		OR_Gecko_getUS_a = OR_Gecko_getUS_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_Gecko_getUS_r = OR_getI16(OR_Gecko_getUS_a)

	OR_Gecko_getUS_r = OR_Gecko_getUS_r / 100 'get mm from 1/100mm

RetProc OR_Gecko_getUS = OR_Gecko_getUS_r
EndProc



'FUNCTION: Check, that is device connected or not
'@param OR_Gecko_isConn_inst Gecko device instance: 1 = single or primary, 2 = secondary in dual configuration
'@ret 0 = not connected, 1 = device connected
UsrProc OR_Gecko_isConn( OR_Gecko_isConn_inst AS INTEGER ) AS INTEGER
	DIM OR_Gecko_isConn_a AS INTEGER = 0 'address
	DIM OR_Gecko_isConn_r AS INTEGER = 0 'return value

	'Set bit address
	OR_Gecko_isConn_a = 1

	'Set offset according primary (single) or secondary
	IF OR_Gecko_isConn_inst = 1
		OR_Gecko_isConn_a = OR_Gecko_isConn_a + OR_primR_bitOffset
	ELSE
		OR_Gecko_isConn_a = OR_Gecko_isConn_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_Gecko_isConn_r = OR_getU16(OR_Gecko_isConn_a)
	
	IF OR_Gecko_isConn_r = 48
		OR_Gecko_isConn_r = 1
	ELSE
		OR_Gecko_isConn_r = 0
	ENDIF

RetProc OR_Gecko_isConn= OR_Gecko_isConn_r
EndProc



'FUNCTION: Check, that is part detected or not
'@param OR_Gecko_isPart_inst Gecko device instance: 1 = single or primary, 2 = secondary in dual configuration
'@ret 0 = part not detected, 1 = part detected
UsrProc OR_Gecko_isPart( OR_Gecko_isPart_inst AS INTEGER ) AS INTEGER
	DIM OR_Gecko_isPart_a AS INTEGER = 0 'address
	DIM OR_Gecko_isPart_r AS INTEGER = 0 'return value

	'Set bit address
	OR_Gecko_isPart_a = 17

	'Set offset according primary (single) or secondary
	IF OR_Gecko_isPart_inst = 1
		OR_Gecko_isPart_a = OR_Gecko_isPart_a + OR_primR_bitOffset
	ELSE
		OR_Gecko_isPart_a = OR_Gecko_isPart_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	OR_Gecko_isPart_r = I[OR_Gecko_isPart_a + OR_FieldBUS_SB - 1]


RetProc OR_Gecko_isPart= OR_Gecko_isPart_r
EndProc



'FUNCTION: Get pad worn state
'@param OR_Gecko_padSt_inst Gecko device instance: 1 = single or primary, 2 = secondary in dual configuration
'@ret 0 = pads are good (no error), 1 = pads are worn
UsrProc OR_Gecko_padSt( OR_Gecko_padSt_inst AS INTEGER ) AS INTEGER
	DIM OR_Gecko_padSt_a AS INTEGER = 0 'address
	DIM OR_Gecko_padSt_r AS INTEGER = 0 'return value

	'Set bit address
	OR_Gecko_padSt_a = 18

	'Set offset according primary (single) or secondary
	IF OR_Gecko_padSt_inst = 1
		OR_Gecko_padSt_a = OR_Gecko_padSt_a + OR_primR_bitOffset
	ELSE
		OR_Gecko_padSt_a = OR_Gecko_padSt_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	OR_Gecko_padSt_r = I[OR_Gecko_padSt_a + OR_FieldBUS_SB - 1]


RetProc OR_Gecko_padSt= OR_Gecko_padSt_r
EndProc



'FUNCTION: Get pad position
'@param OR_Gecko_padPos_inst Gecko device instance: 1 = single or primary, 2 = secondary in dual configuration
'@ret 1=pad out, 0=pad in
UsrProc OR_Gecko_padPos( OR_Gecko_padPos_inst AS INTEGER ) AS INTEGER
	DIM OR_Gecko_padPos_a AS INTEGER = 0 'address
	DIM OR_Gecko_padPos_r AS INTEGER = 0 'return value

	'Set bit address
	OR_Gecko_padPos_a = 19

	'Set offset according primary (single) or secondary
	IF OR_Gecko_padPos_inst = 1
		OR_Gecko_padPos_a = OR_Gecko_padPos_a + OR_primR_bitOffset
	ELSE
		OR_Gecko_padPos_a = OR_Gecko_padPos_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	OR_Gecko_padPos_r = I[OR_Gecko_padPos_a + OR_FieldBUS_SB - 1]

RetProc OR_Gecko_padPos= OR_Gecko_padPos_r
EndProc




'FUNCTION: Get HEX values
'@param OR_HEX_get_f: 	reqested force/torque instance, valid inputs: Fx, Fy, Fz, Tx, Ty, Tz
'				force values are in 1/10N, torque values are in 1/100Nm
'				eg.: Fz = sensor force value on z axis, Tx = sensor torque value on x axis
UsrProc OR_HEX_get(OR_HEX_get_f AS STRING) AS INTEGER
	DIM OR_HEX_get_r AS INTEGER = 0 'return value
	DIM OR_HEX_get_a AS INTEGER = 0 'address
	
	IF OR_HEX_get_f = "Fx"
		OR_HEX_get_a = 65 + OR_HEXrOffset
	ELSEIF OR_HEX_get_f = "Fy"
		OR_HEX_get_a = 81 + OR_HEXrOffset
	ELSEIF OR_HEX_get_f = "Fz"
		OR_HEX_get_a = 97 + OR_HEXrOffset
	ELSEIF OR_HEX_get_f = "Tx"
		OR_HEX_get_a = 113 + OR_HEXrOffset
	ELSEIF OR_HEX_get_f = "Ty"
		OR_HEX_get_a = 129 + OR_HEXrOffset
	ELSEIF OR_HEX_get_f = "Tz"
		OR_HEX_get_a = 145 + OR_HEXrOffset
	ELSE
		L1% = 0
		OR_HEX_get_r = 0
	ENDIF
	
	IF OR_HEX_get_a > 0 
		CallProc OR_HEX_get_r = OR_getI16(OR_HEX_get_a)
	ENDIF

RetProc OR_HEX_get = OR_HEX_get_r
EndProc



'FUNCTION: Zeroing the HEX sensor values (the actual force/torque will be 0)
UsrProc OR_HEX_zero()

	SETM O[2 + OR_HEXrOffset + OR_FieldBUS_SB - 1], 0 'Reset unzero bit
	SETM O[1 + OR_HEXrOffset + OR_FieldBUS_SB - 1], 1 'Set zero bit
	STIMER 0.1
	SETM O[1 + OR_HEXrOffset + OR_FieldBUS_SB - 1], 0 'Reset zero bit

EndProc



'FUNCTION: Unzero the HEX sensor
UsrProc OR_HEX_unzero()

	SETM O[1 + OR_HEXrOffset + OR_FieldBUS_SB - 1], 0 'Reset zero bit
	SETM O[2 + OR_HEXrOffset + OR_FieldBUS_SB - 1], 1 'Set unzero bit
	STIMER 0.1
	SETM O[2 + OR_HEXrOffset + OR_FieldBUS_SB - 1], 0 'Reset unzero bit

EndProc



'FUNCTION: Check that is device connected or not
'@ret 1 = connected, 0 = not connected
UsrProc OR_HEX_isConn() AS INTEGER
	DIM OR_HEX_isConn_a AS INTEGER = 0 'address
	DIM OR_HEX_isConn_r AS INTEGER = 0 'return value

	'Set bit address
	OR_HEX_isConn_a = 1 + OR_HEXrOffset

	'Get data
	CallProc OR_HEX_isConn_r = OR_getU16(OR_HEX_isConn_a)
	
	IF OR_HEX_isConn_r = 64
		OR_HEX_isConn_r = 1
	ELSE
		OR_HEX_isConn_r = 0
	ENDIF

RetProc OR_HEX_isConn = OR_HEX_isConn_r
EndProc

'FUNCTION: User set Sensor Filter Rate 
'@param .setFilter user input values 1-7 corresponding to table below
UsrProc OR_HEX_setFilter(OR_HEX_setFilter AS INTEGER )
		' 1 = No filter
		' 2 = 500 Hz
		' 3 = 150 Hz 
		' 4 = 50 Hz 
		' 5 = 15 Hz
		' 6 = 5 Hz
		' 7 = 1.5 Hz 

	DIM OR_HEX_setFilt_a = 0 AS INTEGER
	DIM OR_HEX_setFilt_val = 0 AS INTEGER
	OR_HEX_setFilt_a = 17 + OR_HEXrOffset 
	
	SWITCH OR_HEX_setFilter
		CASE 1
			OR_HEX_setFilt_val  = 1
			CallProc OR_setU16(OR_HEX_setFilt_a, OR_HEX_setFilt_val )
			BREAK
		CASE 2
			OR_HEX_setFilt_val  = 2
			CallProc OR_setU16(OR_HEX_setFilt_a, OR_HEX_setFilt_val )
			BREAK	
		CASE 3
			OR_HEX_setFilt_val  = 3
			CallProc OR_setU16(OR_HEX_setFilt_a, OR_HEX_setFilt_val )
			BREAK
		CASE 4
			OR_HEX_setFilt_val  = 4
			CallProc OR_setU16(OR_HEX_setFilt_a, OR_HEX_setFilt_val )
			BREAK
		CASE 5
			OR_HEX_setFilt_val  = 5
			CallProc OR_setU16(OR_HEX_setFilt_a, OR_HEX_setFilt_val )
			BREAK
		CASE 6
			OR_HEX_setFilt_val  = 6
			CallProc OR_setU16(OR_HEX_setFilt_a, OR_HEX_setFilt_val )
			BREAK
		CASE 7
			OR_HEX_setFilt_val  = 7
			CallProc OR_setU16(OR_HEX_setFilt_a, OR_HEX_setFilt_val )
			BREAK
	ENDS
EndProc


'FUNCTION: Open/Close gripper to specific dictance (mm) with specific force (N)
'@param OR_RGx_move_width open/close distance (mm)
'@param OR_RGx_move_force force (N)
'@param OR_RGx_move_wait shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_RG2FT_move( OR_RG2FT_move_width AS INTEGER, OR_RG2FT_move_force AS INTEGER, OR_RG2FT_move_wait AS INTEGER )
	DIM OR_RG2FT_move_addr AS INTEGER = 0
	DIM OR_RG2FT_move_val AS INTEGER = 0

	'Set width
	OR_RG2FT_move_addr = 1 + OR_primW_bitOffset
	OR_RG2FT_move_val = OR_RG2FT_move_width*10 'Width is sent as 1/10mm 
	CallProc OR_setU16(OR_RG2FT_move_addr, OR_RG2FT_move_val )

	'Set force
	OR_RG2FT_move_addr = 17 + OR_primW_bitOffset
	OR_RG2FT_move_val = OR_RG2FT_move_force*10 'Force is sent as 1/10N
	CallProc OR_setU16(OR_RG2FT_move_addr,  OR_RG2FT_move_val )

	'Start move
	SETM O[34 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset motion stop bit
	SETM O[33 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],1 'Set start motion bit
	STIMER 0.1
	SETM O[33 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset start motion bit

	'Wait for gripper motion if needed
	IF OR_RG2FT_move_wait = 1
		STIMER 0.5
		WAITJ I[305 + OR_primW_bitOffset + OR_FieldBUS_SB - 1]
	ENDIF

EndProc



'FUNCTION: Stop the gripper motion
UsrProc OR_RG2FT_stop()

	SETM O[33 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset start motion bit
	SETM O[34 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],1 'Set motion stop bit
	STIMER 0.1
	SETM O[34 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset motion stop bit

EndProc



'FUNCTION: Set actual value as offset for proximity
UsrProc OR_RG2FT_pOffsAct()

	SETM O[113 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset actual measured value bit 
	SETM O[114 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset custom value bit
	STIMER 0.1
	SETM O[113 + OR_primW_bitOffset + OR_FieldBUS_SB - 1], 1 'Set control
	STIMER 0.1
	SETM O[113 + OR_primW_bitOffset + OR_FieldBUS_SB - 1], 0 'Reset control

EndProc

'FUNCTION: Set custom offset for proximity
'@param OR_RGx_pOffsVaL_L left proximity offset (mm)
'@param OR_RGx_pOffsVaL_R right proximity offset (mm)
UsrProc OR_RG2FT_pOffsVaL( OR_RG2FT_pOffsVaL_L AS INTEGER, OR_RG2FT_pOffsVaL_R AS INTEGER)
	DIM OR_RG2FT_pOffsVaL_a AS INTEGER = 0 'address
	DIM OR_RG2FT_pOffsVaL_v AS INTEGER = 0 'value

	'Set left offset value
	OR_RG2FT_pOffsVaL_a = 81 + OR_primW_bitOffset
	CallProc OR_setU16(OR_RG2FT_pOffsVaL_a, OR_RG2FT_pOffsVaL_L )

	'Set right offset value
	OR_RG2FT_pOffsVaL_a = 97 + OR_primW_bitOffset
	CallProc OR_setU16(OR_RG2FT_pOffsVaL_a,  OR_RG2FT_pOffsVaL_R )

	'Select offset type
	SETM O[113 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset actual measured value bit 
	SETM O[114 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset custom value bit
	STIMER 0.1
	SETM O[114 + OR_primW_bitOffset + OR_FieldBUS_SB - 1],1 'Set custom offset value bit
	STIMER 0.1
	SETM O[114+ OR_primW_bitOffset + OR_FieldBUS_SB - 1],0 'Reset custom offset value bit R

EndProc

'FUNCTION: 
UsrProc OR_RG2FT_hexZero()

	SETM O[50 + OR_primW_bitOffset + OR_FieldBUS_SB - 1], 0 'Reset unzero bit
	SETM O[49 + OR_primW_bitOffset + OR_FieldBUS_SB - 1], 1 'Set zero bit
	STIMER 0.1
	SETM O[49 + OR_primW_bitOffset + OR_FieldBUS_SB - 1], 0 'Reset zero bit

EndProc

'FUNCTION: 
UsrProc OR_RG2FT_hexUnzero()

	SETM O[49 + OR_primW_bitOffset +  OR_FieldBUS_SB - 1], 0 'Reset zero bit
	SETM O[50 + OR_primW_bitOffset + OR_FieldBUS_SB - 1], 1 'Set unzero bit
	STIMER 0.1
	SETM O[50 + OR_primW_bitOffset + OR_FieldBUS_SB - 1], 0 'Reset unzero bit

EndProc

'FUNCTION: Get left proximity value (mm)
UsrProc OR_RG2FT_getLProx() AS INTEGER
	DIM OR_RG2FT_getLProx_r AS INTEGER = 0 'return value
	DIM OR_RG2FT_getLProx_a AS INTEGER = 0 'address
	
	OR_RG2FT_getLProx_a = 225 + OR_primR_bitOffset
	CallProc OR_RG2FT_getLProx_r = OR_getI16(OR_RG2FT_getLProx_a)

RetProc OR_RG2FT_getLProx = OR_RG2FT_getLProx_r
EndProc

'FUNCTION: Get right proximity value (mm)
UsrProc OR_RG2FT_getRProx() AS INTEGER
	DIM OR_RG2FT_getRProx_r AS INTEGER = 0 'return value
	DIM OR_RG2FT_getRProx_a AS INTEGER = 0 'address
	
	OR_RG2FT_getRProx_a = 257 + OR_primR_bitOffset
	CallProc OR_RG2FT_getRProx_r = OR_getI16(OR_RG2FT_getRProx_a)

RetProc OR_RG2FT_getRProx = OR_RG2FT_getRProx_r
EndProc

'FUNCTION: User set Sensor Filter Rate 
'@param .setFilter user input values 1-7 corresponding to table below
UsrProc OR_RG2FT_setFilter(OR_RG2FT_setFilter AS INTEGER )
		' 1 = No filter
		' 2 = 500 Hz
		' 3 = 150 Hz 
		' 4 = 50 Hz 
		' 5 = 15 Hz
		' 6 = 5 Hz
		' 7 = 1.5 Hz 

	DIM OR_RG2FT_setFilt_a AS INTEGER = 0 
	DIM OR_RG2FT_setFilt_val AS INTEGER = 0 
	OR_RG2FT_setFilt_a = 65 
	
	SWITCH OR_RG2FT_setFilter
		CASE 1
			OR_RG2FT_setFilt_val  = 1
			CallProc OR_setU16(OR_RG2FT_setFilt_a, OR_RG2FT_setFilt_val )
			BREAK
		CASE 2
			OR_RG2FT_setFilt_val  = 2
			CallProc OR_setU16(OR_RG2FT_setFilt_a, OR_RG2FT_setFilt_val )
			BREAK	
		CASE 3
			OR_RG2FT_setFilt_val  = 3
			CallProc OR_setU16(OR_RG2FT_setFilt_a, OR_RG2FT_setFilt_val )
			BREAK
		CASE 4
			OR_RG2FT_setFilt_val  = 4
			CallProc OR_setU16(OR_RG2FT_setFilt_a, OR_RG2FT_setFilt_val )
			BREAK
		CASE 5
			OR_RG2FT_setFilt_val  = 5
			CallProc OR_setU16(OR_RG2FT_setFilt_a, OR_RG2FT_setFilt_val )
			BREAK
		CASE 6
			OR_RG2FT_setFilt_val  = 6
			CallProc OR_setU16(OR_RG2FT_setFilt_a, OR_RG2FT_setFilt_val )
			BREAK
		CASE 7
			OR_RG2FT_setFilt_val  = 7
			CallProc OR_setU16(OR_RG2FT_setFilt_a, OR_RG2FT_setFilt_val )
			BREAK
	ENDS
EndProc



'FUNCTION: Get HEX values
'@param OR_RG2FT_getHex_f: 	reqested force/torque instance, valid inputs: lFx, lFy, lFz, lTx, lTy, lTz, rFx, rFy, rFz, rTx, rTy, rTz
'				force values are in 1/10N, torque values are in 1/100Nm
'				eg.: lFz = left sensor force value on z axis, rTx = right sensor torque value on x axis
UsrProc OR_RG2FT_getHex(OR_RG2FT_getHex_f AS STRING) AS INTEGER
	DIM OR_RG2FT_getHex_r AS INTEGER = 0 'return value
	DIM OR_RG2FT_getHex_a AS INTEGER = 0 'address

	IF OR_RG2FT_getHex_f = "lFx"
		OR_RG2FT_getHex_a = 33 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
	ELSEIF OR_RG2FT_getHex_f = "lFy"
		OR_RG2FT_getHex_a = 49 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
	ELSEIF OR_RG2FT_getHex_f = "lFz"
		OR_RG2FT_getHex_a = 65 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
	ELSEIF OR_RG2FT_getHex_f = "lTx"
		OR_RG2FT_getHex_a = 81 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
		OR_RG2FT_getHex_r = OR_RG2FT_getHex_r / 10
	ELSEIF OR_RG2FT_getHex_f = "lTy"
		OR_RG2FT_getHex_a = 97 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
		OR_RG2FT_getHex_r = OR_RG2FT_getHex_r / 10
	ELSEIF OR_RG2FT_getHex_f = "lTz"
		OR_RG2FT_getHex_a = 113 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
		OR_RG2FT_getHex_r = OR_RG2FT_getHex_r / 10
	ELSEIF OR_RG2FT_getHex_f = "rFx"
		OR_RG2FT_getHex_a = 129 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
	ELSEIF OR_RG2FT_getHex_f = "rFy"
		OR_RG2FT_getHex_a = 145 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
	ELSEIF OR_RG2FT_getHex_f = "rFz"
		OR_RG2FT_getHex_a = 161 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
	ELSEIF OR_RG2FT_getHex_f = "rTx"
		OR_RG2FT_getHex_a = 177 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
		OR_RG2FT_getHex_r = OR_RG2FT_getHex_r / 10
	ELSEIF OR_RG2FT_getHex_f = "rTy"
		OR_RG2FT_getHex_a = 193 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
		OR_RG2FT_getHex_r = OR_RG2FT_getHex_r / 10
	ELSEIF OR_RG2FT_getHex_f = "rTz"
		OR_RG2FT_getHex_a = 209 + OR_primR_bitOffset
		CallProc OR_RG2FT_getHex_r = OR_getI16(OR_RG2FT_getHex_a)
		OR_RG2FT_getHex_r = OR_RG2FT_getHex_r / 10
	ELSE
		OR_RG2FT_getHex_a = 0
		OR_RG2FT_getHex_r = 0
	ENDIF

	OR_RG2FT_getHex_r = OR_RG2FT_getHex_r / 10


RetProc OR_RG2FT_getHex = OR_RG2FT_getHex_r
EndProc



'FUNCTION: Get gripper actual width (mm)
'@ret Actual width in mm
UsrProc OR_RG2FT_getWidth() AS INTEGER
	DIM OR_RG2FT_getWidth_r AS INTEGER = 0 'return value
	DIM OR_RG2FT_getWidth_a AS INTEGER = 0 'address
	
	OR_RG2FT_getWidth_a = 289 + OR_primR_bitOffset
	CallProc OR_RG2FT_getWidth_r = OR_getI16(OR_RG2FT_getWidth_a)

	OR_RG2FT_getWidth_r = OR_RG2FT_getWidth_r/10 'to mm

RetProc OR_RG2FT_getWidth = OR_RG2FT_getWidth_r
EndProc



'FUNCTION: Check that is device connected or not
'@ret 1 = connected, 0 = not connected
UsrProc OR_RG2FT_isConn() AS INTEGER
	DIM OR_RG2FT_isConn_a AS INTEGER = 0 'address
	DIM OR_RG2FT_isConn_r AS INTEGER = 0 'return value

	'Set bit address
	OR_RG2FT_isConn_a = 1 + OR_primR_bitOffset

	'Get data
	CallProc OR_RG2FT_isConn_r = OR_getU16(OR_RG2FT_isConn_a)
	
	IF OR_RG2FT_isConn_r = 34
		OR_RG2FT_isConn_r = 1
	ELSE
		OR_RG2FT_isConn_r = 0
	ENDIF

RetProc OR_RG2FT_isConn = OR_RG2FT_isConn_r
EndProc



'FUNCTION: Get gripper status (busy)
'@ret 1 = busy, 0= idle
UsrProc OR_RG2FT_isBusy() AS INTEGER
	DIM OR_RG2FT_isBusy_a AS INTEGER = 0 'address
	DIM OR_RG2FT_isBusy_r AS INTEGER = 0 'return value

	'Set bit address
	OR_RG2FT_isBusy_a = 305 + OR_primR_bitOffset + OR_FieldBUS_SB -1

	'Get bitstatus
	OR_RG2FT_isBusy_r = I[OR_RG2FT_isBusy_a]

RetProc OR_RG2FT_isBusy = OR_RG2FT_isBusy_r
EndProc



'FUNCTION: Check, that is grip detected or not (part gripped)
'@ret 1 = grip detected, 0 = no grip detected
UsrProc OR_RG2FT_isGrip() AS INTEGER
	DIM OR_RG2FT_isGrip_a AS INTEGER = 0 'address
	DIM OR_RG2FT_isGrip_r AS INTEGER = 0 'return value

	'Set bit address
	OR_RG2FT_isGrip_a = 306 + OR_primR_bitOffset + OR_FieldBUS_SB -1

	'Get bitstatus
	OR_RG2FT_isGrip_r = I[OR_RG2FT_isGrip_a]

RetProc OR_RG2FT_isGrip = OR_RG2FT_isGrip_r
EndProc


'FUNCTION: Check for LEFT PROX SENSOR error
'@ret 1 = ERROR detected, 0 = NO ERROR detected
UsrProc OR_RG2FT_LProxErr() AS INTEGER 

	DIM LProxErr_a AS INTEGER = 0 'address
	DIM LProxErr_r AS INTEGER = 0 'return value

	'Set bit address
	LProxErr_a = 307 + OR_primR_bitOffset + OR_FieldBUS_SB -1

	'Get bitstatus
	LProxErr_r = I[LProxErr_a]
RetProc OR_RG2FT_LProxErr = LProxErr_r
EndProc

'FUNCTION: Check for RIGHT PROX SENSOR error
'@ret 1 = ERROR detected, 0 = NO ERROR detected
UsrProc OR_RG2FT_RProxErr() AS INTEGER 

	DIM RProxErr_a AS INTEGER = 0 'address
	DIM RProxErr_r AS INTEGER = 0 'return value

	'Set bit address
	RProxErr_a = 308 + OR_primR_bitOffset + OR_FieldBUS_SB -1

	'Get bitstatus
	RProxErr_r = I[RProxErr_a]
RetProc OR_RG2FT_RProxErr = RProxErr_r
EndProc

'FUNCTION: Check for LEFT SENSOR error
'@ret 1 = ERROR detected, 0 = NO ERROR detected
UsrProc OR_RG2FT_LHexErr() AS INTEGER 

	DIM LHexErr_a AS INTEGER = 0 'address
	DIM LHexErr_r AS INTEGER = 0 'return value

	'Set bit address
	LHexErr_a = 309 + OR_primR_bitOffset + OR_FieldBUS_SB -1

	'Get bitstatus
	LHexErr_r = I[LHexErr_a]
RetProc OR_RG2FT_LHexErr = LHexErr_r
EndProc

'FUNCTION: Check for RIGHT SENSOR error
'@ret 1 = ERROR detected, 0 = NO ERROR detected
UsrProc OR_RG2FT_RHexErr() AS INTEGER 

	DIM RHexErr_a AS INTEGER = 0 'address
	DIM RHexErr_r AS INTEGER = 0 'return value

	'Set bit address
	RHexErr_a = 310 + OR_primR_bitOffset + OR_FieldBUS_SB -1

	'Get bitstatus
	RHexErr_r = I[RHexErr_a]
RetProc OR_RG2FT_RHexErr = RHexErr_r
EndProc

'FUNCTION: Get sensor filter rate value
UsrProc OR_RG2FT_getFilter() AS INTEGER
	
	DIM getFilt_a AS INTEGER = 0
	DIM getFilt_r AS INTEGER = 0

	'Set Bit address
	getFilt_a = 17 + OR_primR_bitOffset
	'Get data
	CallProc getFilt_r = OR_getU16(getFilt_a)

RetProc OR_RG2FT_getFilter = getFilt_r
EndProc



'FUNCTION: Grip or release with VG10/VGC10
'@param OR_VG10_grip_inst Gripper instance 1 = primary(or single), 2 = secondary
'@param OR_VG10_grip_vacA Vacuum level of channel A in %
'@param OR_VG10_grip_vacB Vacuum level of channel B in %
'@param OR_VG10_grip_wait Wait until the vacuum builds up: 0=don't wait, 1=wait untilt the vacuum reaches the required level
UsrProc OR_VG10_grip(OR_VG10_grip_inst AS INTEGER, OR_VG10_grip_vacA AS INTEGER, OR_VG10_grip_vacB AS INTEGER, OR_VG10_grip_wait AS INTEGER )
	
	DIM OR_VG10_grip_addrA AS INTEGER = 0
	DIM OR_VG10_grip_valA AS INTEGER = 0
	DIM OR_VG10_grip_addrB AS INTEGER = 0
	DIM OR_VG10_grip_valB AS INTEGER = 0
	DIM OR_VG10_grip_bitOffs AS INTEGER = 0
	DIM OR_VG10_grip_vA AS INTEGER = 0
	DIM OR_VG10_grip_vB AS INTEGER = 0

	'Set offset according primary (single) or secondary
	IF OR_VG10_grip_inst = 1
		OR_VG10_grip_bitOffs = OR_primW_bitOffset
	ELSE
		OR_VG10_grip_bitOffs = OR_secW_bitOffset
	ENDIF

	'Control byte lowest bit always on (idle) not used
	SETM O[1 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  1
	SETM O[17 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  1

	'Set vacuum if needed
	IF OR_VG10_grip_vacA > 0
		OR_VG10_grip_addrA = 33 + OR_VG10_grip_bitOffs
		CallProc OR_setU16(OR_VG10_grip_addrA,  OR_VG10_grip_vacA )
	ENDIF

	IF OR_VG10_grip_vacB > 0
		OR_VG10_grip_addrB = 49 + OR_VG10_grip_bitOffs
		CallProc OR_setU16(OR_VG10_grip_addrB, OR_VG10_grip_vacB )
	ENDIF

	'Control gripper according operation types
	IF OR_VG10_grip_vacA = 0 AND OR_VG10_grip_vacB = 0
		SETM O[2 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  1
		SETM O[18 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  1
		OR_VG10_grip_wait = 0 'not need to wait if both channel is released
	ELSEIF OR_VG10_grip_vacA > 0 AND OR_VG10_grip_vacB > 0
		SETM O[2 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  0
		SETM O[18 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  0
	ELSEIF OR_VG10_grip_vacA = 0 AND OR_VG10_grip_vacB > 0
		SETM O[2 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  1
		SETM O[18 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  0
	ELSE
		SETM O[2 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  0
		SETM O[18 + OR_VG10_grip_bitOffs + OR_FieldBUS_SB -1],  1
	ENDIF

	'If  we have to wait for the vacuum reach the achived level
	WHILE OR_VG10_grip_wait
		STIMER 0.1
		CallProc OR_VG10_grip_vA = OR_VG10_getVacA(OR_VG10_grip_inst)
		CallProc OR_VG10_grip_vB = OR_VG10_getVacB(OR_VG10_grip_inst)
		IF OR_VG10_grip_vA >= OR_VG10_grip_vacA AND OR_VG10_grip_vB >= OR_VG10_grip_vacB
			OR_VG10_grip_wait = 0
		ENDIF
	ENDW

EndProc



'FUNCTION: Set current limit for VG10/VGC10
'@param OR_VG10_setCur_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_VG10_setCur_mA Current limit in mA, valid range: 100-1000
UsrProc OR_VG10_setCur(OR_VG10_setCur_inst AS INTEGER, OR_VG10_setCur_mA AS INTEGER )
	
	DIM OR_VG10_setCur_addr AS INTEGER = 0

	OR_VG10_setCur_addr = 65

	'Shift address according primary (single) or secondary
	IF OR_VG10_setCur_inst = 1
		OR_VG10_setCur_addr = OR_VG10_setCur_addr + OR_primW_bitOffset
	ELSE
		OR_VG10_setCur_addr = OR_VG10_setCur_addr + OR_secW_bitOffset
	ENDIF

	'Write register
	CallProc OR_setU16(OR_VG10_setCur_addr, OR_VG10_setCur_mA)

EndProc



'FUNCTION: Check VG10/VGC10 connection
'@param OR_VG10_isConn_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret VG10/VGC10 connection: 0=not connected, 1= VG10 connected, 2= VGC10 connected. 
UsrProc OR_VG10_isConn(OR_VG10_isConn_inst AS INTEGER ) AS INTEGER
	
	DIM OR_VG10_isConn_addr AS INTEGER = 0
	DIM OR_VG10_isConn_ret AS INTEGER = 0

	'Set bit address
	OR_VG10_isConn_addr = 1

	'Set offset according primary (single) or secondary
	IF OR_VG10_isConn_inst = 1
		OR_VG10_isConn_addr = OR_VG10_isConn_addr + OR_primR_bitOffset
	ELSE
		OR_VG10_isConn_addr = OR_VG10_isConn_addr + OR_secR_bitOffset
	ENDIF

	OR_VG10_isConn_addr = OR_VG10_isConn_addr 

	'Get data
	CallProc OR_VG10_isConn_ret = OR_getU16(OR_VG10_isConn_addr)
	
	IF OR_VG10_isConn_ret <> 0

		IF OR_VG10_isConn_ret = 16
			OR_VG10_isConn_ret = 1
		ENDIF

		IF OR_VG10_isConn_ret = 17
			OR_VG10_isConn_ret = 2
		ENDIF

	ELSE
		OR_VG10_isConn_ret = 0
	ENDIF

RetProc OR_VG10_isConn = OR_VG10_isConn_ret
EndProc



'FUNCTION: Get actual current limit
'@param OR_VG10_getLim_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Current limit in mA
UsrProc OR_VG10_getLim( OR_VG10_getLim_inst AS INTEGER ) AS INTEGER
	DIM OR_VG10_getLim_addr AS INTEGER = 0
	DIM OR_VG10_getLim_ret AS INTEGER = 0

	'Set bit address
	OR_VG10_getLim_addr = 17

	'Set offset according primary (single) or secondary
	IF OR_VG10_getLim_inst = 1
		OR_VG10_getLim_addr = OR_VG10_getLim_addr + OR_primR_bitOffset
	ELSE
		OR_VG10_getLim_addr = OR_VG10_getLim_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_VG10_getLim_ret = OR_getU16(OR_VG10_getLim_addr)

RetProc OR_VG10_getLim = OR_VG10_getLim_ret
EndProc



'FUNCTION: Get vacuum level of channel A
'@param OR_VG10_getVacA_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Vacuum level in %
UsrProc OR_VG10_getVacA( OR_VG10_getVacA_inst AS INTEGER ) AS INTEGER
	DIM OR_VG10_getVacA_addr AS INTEGER = 0
	DIM OR_VG10_getVacA_ret AS INTEGER = 0

	'Set bit address
	OR_VG10_getVacA_addr = 33

	'Set offset according primary (single) or secondary
	IF OR_VG10_getVacA_inst = 1
		OR_VG10_getVacA_addr = OR_VG10_getVacA_addr + OR_primR_bitOffset
	ELSE
		OR_VG10_getVacA_addr = OR_VG10_getVacA_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_VG10_getVacA_ret = OR_getU16(OR_VG10_getVacA_addr)

	OR_VG10_getVacA_ret = OR_VG10_getVacA_ret / 10 'get % from 1/10%

RetProc OR_VG10_getVacA = OR_VG10_getVacA_ret
EndProc



'FUNCTION: Get vacuum level of channel B
'@param OR_VG10_getVacB_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Vacuum level in %
UsrProc OR_VG10_getVacB( OR_VG10_getVacB_inst AS INTEGER ) AS INTEGER
	DIM OR_VG10_getVacB_addr AS INTEGER = 0
	DIM OR_VG10_getVacB_ret AS INTEGER = 0

	'Set bit address
	OR_VG10_getVacB_addr = 49

	'Set offset according primary (single) or secondary
	IF OR_VG10_getVacB_inst = 1
		OR_VG10_getVacB_addr = OR_VG10_getVacB_addr + OR_primR_bitOffset
	ELSE
		OR_VG10_getVacB_addr = OR_VG10_getVacB_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_VG10_getVacB_ret = OR_getU16(OR_VG10_getVacB_addr)

	OR_VG10_getVacB_ret = OR_VG10_getVacB_ret / 10 'get % from 1/10%

RetProc OR_VG10_getVacB = OR_VG10_getVacB_ret
EndProc



'FUNCTION: Open/Close gripper to specific dictance (mm) with specific force (N)
'@param OR_RGx_move_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_RGx_move_width open/close distance (mm)
'@param OR_RGx_move_force force (N)
'@param OR_RGx_move_wait shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_RGx_move(OR_RGx_move_inst AS INTEGER, OR_RGx_move_width AS INTEGER, OR_RGx_move_force AS INTEGER, OR_RGx_move_wait AS INTEGER )
	DIM OR_RGx_move_addr AS INTEGER = 0
	DIM OR_RGx_move_val AS INTEGER = 0
	DIM OR_RGx_move_offsW AS INTEGER = 0
	DIM OR_RGx_move_offsR AS INTEGER = 0

	'Set offset according primary (single) or secondary
	IF OR_RGx_move_inst = 1
		OR_RGx_move_offsW = OR_primW_bitOffset
		OR_RGx_move_offsR =OR_primR_bitOffset
	ELSE
		OR_RGx_move_offsW = OR_secW_bitOffset
		OR_RGx_move_offsR = OR_secR_bitOffset
	ENDIF

	'Set width
	OR_RGx_move_addr = 1 + OR_RGx_move_offsW 
	OR_RGx_move_val = OR_RGx_move_width*10 'Width is sent as 1/10mm 
	CallProc OR_setU16(OR_RGx_move_addr, OR_RGx_move_val )

	'Set force
	OR_RGx_move_addr = 17 + OR_RGx_move_offsW 
	OR_RGx_move_val = OR_RGx_move_force*10 'Force is sent as 1/10N
	CallProc OR_setU16(OR_RGx_move_addr,  OR_RGx_move_val )

	'Start move
	SETM O[34 + OR_RGx_move_offsW + OR_FieldBUS_SB - 1],0 'Reset motion stop bit
	SETM O[33 + OR_RGx_move_offsW + OR_FieldBUS_SB - 1],1 'Set start motion bit
	STIMER 0.1
	SETM O[33 + OR_RGx_move_offsW + OR_FieldBUS_SB - 1],0 'Reset start motion bit

	'Wait for gripper motion if needed
	IF OR_RGx_move_wait = 1
		STIMER 0.5
		WAITJ I[65 + OR_RGx_move_offsR + OR_FieldBUS_SB - 1]
	ENDIF

EndProc




'FUNCTION: Check gripper connection
'@ret Connection state: 0=not connected, 1=connected
UsrProc OR_RGx_isConn(OR_RGx_isConn_inst AS INTEGER ) AS INTEGER
	DIM OR_RGx_isConn_addr AS INTEGER = 0
	DIM OR_RGx_isConn_ret AS INTEGER = 0

	'Set bit address
	OR_RGx_isConn_addr = 1

	'Set offset according primary (single) or secondary
	IF OR_RGx_isConn_inst = 1
		OR_RGx_isConn_addr = OR_RGx_isConn_addr + OR_primR_bitOffset
	ELSE
		OR_RGx_isConn_addr = OR_RGx_isConn_addr + OR_secR_bitOffset
	ENDIF

	OR_RGx_isConn_addr = OR_RGx_isConn_addr
	
	'Get data
	CallProc OR_RGx_isConn_ret = OR_getU16(OR_RGx_isConn_addr)
	
	IF OR_RGx_isConn_ret = 32 OR OR_RGx_isConn_ret = 33
		OR_RGx_isConn_ret = 1
	ELSE
		OR_RGx_isConn_ret = 0
	ENDIF

RetProc OR_RGx_isConn = OR_RGx_isConn_ret
EndProc




'FUNCTION: Check grip detected
'@ret Grip detected: 0=no grip, 1=grip detected
UsrProc OR_RGx_isGrip(OR_RGx_isGrip_inst AS INTEGER ) AS INTEGER
	DIM OR_RGx_isGrip_addr AS INTEGER = 0
	DIM OR_RGx_isGrip_ret AS INTEGER = 0

	'Set bit address
	OR_RGx_isGrip_addr = 66

	'Set offset according primary (single) or secondary
	IF OR_RGx_isGrip_inst = 1
		OR_RGx_isGrip_addr = OR_RGx_isGrip_addr + OR_primR_bitOffset
	ELSE
		OR_RGx_isGrip_addr = OR_RGx_isGrip_addr + OR_secR_bitOffset
	ENDIF

	OR_RGx_isGrip_addr = OR_RGx_isGrip_addr + OR_FieldBUS_SB -1
	
	'Get bit status
	OR_RGx_isGrip_ret = I[OR_RGx_isGrip_addr]

RetProc OR_RGx_isGrip = OR_RGx_isGrip_ret
EndProc



'FUNCTION: Check that is gripper busy or idle
'@param OR_RGx_isBusy_inst Gripper instance: 1=single or primary, 2: secondary in dual configuration
'@ret Gripper state: 0=idle, 1=busy
UsrProc OR_RGx_isBusy(OR_RGx_isBusy_inst AS INTEGER ) AS INTEGER
	DIM OR_RGx_isBusy_addr AS INTEGER = 0
	DIM OR_RGx_isBusy_ret AS INTEGER = 0

	'Set bit address
	OR_RGx_isBusy_addr = 65

	'Set offset according primary (single) or secondary
	IF OR_RGx_isBusy_inst = 1
		OR_RGx_isBusy_addr = OR_RGx_isBusy_addr + OR_primR_bitOffset
	ELSE
		OR_RGx_isBusy_addr = OR_RGx_isBusy_addr + OR_secR_bitOffset
	ENDIF

	OR_RGx_isBusy_addr = OR_RGx_isBusy_addr + OR_FieldBUS_SB -1
	
	'Get bit status
	OR_RGx_isBusy_ret = I[OR_RGx_isBusy_addr]

RetProc OR_RGx_isBusy = OR_RGx_isBusy_ret
EndProc




'FUNCTION: Check safety switch state
'@param OR_RGx_isSSOn_inst Gripper instance: 1=single or primary, 2: secondary in dual configuration
'@ret Safety switch state: 0=none of the safety switches are triggered, 1=safety switch triggered and the gripper is disabled
UsrProc OR_RGx_isSSOn(OR_RGx_isSSOn_inst AS INTEGER ) AS INTEGER
	DIM OR_RGx_isSSOn_addr AS INTEGER = 0
	DIM OR_RGx_isSSOn_offs AS INTEGER = 0
	DIM OR_RGx_isSSOn_ret AS INTEGER = 0


	'Set offset according primary (single) or secondary
	IF OR_RGx_isSSOn_inst = 1
		OR_RGx_isSSOn_offs =  OR_primR_bitOffset
	ELSE
		OR_RGx_isSSOn_offs =  OR_secR_bitOffset
	ENDIF

	'Set bit address
	OR_RGx_isSSOn_addr = 68 + OR_RGx_isSSOn_offs  + OR_FieldBUS_SB -1 'safety circuit 1
	'Get bit status
	OR_RGx_isSSOn_ret = I[OR_RGx_isSSOn_addr]
	
	'If safety circuit 1 is not triggered, check the other one
	IF OR_RGx_isSSOn_ret = 0
		OR_RGx_isSSOn_addr = 70 + OR_RGx_isSSOn_offs  + OR_FieldBUS_SB -1 'safety circuit 2
		
		'Get bit status
		OR_RGx_isSSOn_ret = I[OR_RGx_isSSOn_addr]
	ENDIF

RetProc OR_RGx_isSSOn = OR_RGx_isSSOn_ret
EndProc




'FUNCTION: Set uint16 value to output according the OnRobot regsiter address
'@param OR_setU16_SB starting bit (address) according OnRobot register map
'@param OR_setU16_val uint16 value
UsrProc OR_setU16(OR_setU16_SB As INTEGER, OR_setU16_val AS INTEGER )
	OR_setU16_SB = OR_setU16_SB+OR_FieldBUS_SB-1

	FOR L1%=0 TO 15 STEP 1
		IF(OR_setU16_val mod 2 >= 1)
			SET O[OR_setU16_SB + L1%]
		ELSE
			RESET O[OR_setU16_SB + L1%]
		ENDIF
		OR_setU16_val = OR_setU16_val / 2
	NEXT
	INH
EndProc




'FUNCTION: Get uint16 value from input according the OnRobot regsiter address
'@param OR_getU16_SB starting bit (address) according OnRobot register map
UsrProc OR_getU16(OR_getU16_SB AS INTEGER) AS INTEGER
	DIM OR_getU16_ret AS INTEGER = 0

	OR_getU16_SB = (OR_getU16_SB -1 + OR_FieldBUS_SB - 1 )/8 + 4
	OR_getU16_ret  = GETSIGB(OR_getU16_SB,0)+2^8 * GETSIGB(OR_getU16_SB+1,0)

RetProc OR_getU16 = OR_getU16_ret
EndProc




'FUNCTION: Get int16 value from input according the OnRobot regsiter address
'@param OR_getI16_SB starting bit (address) according OnRobot register map
UsrProc OR_getI16(OR_getI16_SB AS INTEGER) AS INTEGER
	DIM OR_getI16_ret AS INTEGER = 0

	OR_getI16_SB = (OR_getI16_SB -1 + OR_FieldBUS_SB - 1 )/8 + 4
	OR_getI16_ret   = GETSIGB(OR_getI16_SB,0)+2^8 * GETSIGB(OR_getI16_SB+1,0)

	IF OR_getI16_ret  >= 32768
		OR_getI16_ret  = OR_getI16_ret - 65536
	ENDIF

RetProc OR_getI16 = OR_getI16_ret 
EndProc


'FUNCTION: Move gripper to specific diameter (mm)
'@param OR_TFG_move_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_TFG_move_diameter open/close target diameter (mm)
'@param OR_TFG_move_wait shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_TFG_move(OR_TFG_move_inst AS INTEGER, OR_TFG_move_dia AS INTEGER, OR_TFG_move_wait AS INTEGER )
	
	DIM OR_TFG_move_addr AS INTEGER  = 0
	DIM OR_TFG_move_val AS INTEGER  = 0	
	DIM OR_TFG_move_offsW AS INTEGER  = 0
	DIM OR_TFG_move_offsR AS INTEGER  = 0

	'Set offset according primary (single) or secondary
	IF OR_TFG_move_inst = 1
		OR_TFG_move_offsW = OR_primW_bitOffset
		OR_TFG_move_offsR =OR_primR_bitOffset
	ELSE
		OR_TFG_move_offsW = OR_secW_bitOffset
		OR_TFG_move_offsR = OR_secR_bitOffset
	ENDIF

		
	'Set move target diameter
	OR_TFG_move_addr = 33 + OR_TFG_move_offsW 
	OR_TFG_move_val = OR_TFG_move_dia*10 'Target diameter is sent as 1/10mm 
	CallProc OR_setU16(OR_TFG_move_addr, OR_TFG_move_val )

	'Start OR_TFG_primary_control
	
	SETM O[2 + OR_TFG_move_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_TFG_move_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	SETM O[2 + OR_TFG_move_offsW + OR_FieldBUS_SB - 1],1 'Set start motion bit
	SETM O[1 + OR_TFG_move_offsW + OR_FieldBUS_SB - 1],1 'Set start motion bit
	STIMER 0.1
	SETM O[2 + OR_TFG_move_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_TFG_move_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1



	'Wait for gripper motion if needed
	IF OR_TFG_move_wait = 1
		STIMER 0.5
		WAITJ I[17 + OR_TFG_move_offsR + OR_FieldBUS_SB - 1]
	ENDIF


EndProc

'FUNCTION: Grip part to specific internal or external diameter (mm) with specific force (N)
'@param OR_TFG_grip_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_TFG_grip_diameter open/close target diameter (mm)
'@param OR_TFG_grip_force force (%)
'@param OR_TFG_grip_control 1= Internal diameter 2 = External diameter
'@param OR_TFG_grip_wait shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_TFG_grip(OR_TFG_grip_inst AS INTEGER, OR_TFG_grip_diameter AS INTEGER, OR_TFG_grip_force AS INTEGER, OR_TFG_grip_control AS INTEGER, OR_TFG_grip_wait AS INTEGER )
	DIM OR_TFG_grip_addr AS INTEGER  = 0
	DIM OR_TFG_grip_val AS INTEGER  =  0
	DIM OR_TFG_grip_Pcont AS INTEGER  = 0
	DIM OR_TFG_grip_offsW AS INTEGER  = 0
	DIM OR_TFG_grip_offsR AS INTEGER  = 0


	'Set offset according primary (single) or secondary
	IF OR_TFG_grip_inst = 1
		OR_TFG_grip_offsW = OR_primW_bitOffset
		OR_TFG_grip_offsR = OR_primR_bitOffset
	ELSE
		OR_TFG_grip_offsW = OR_secW_bitOffset
		OR_TFG_grip_offsR = OR_secR_bitOffset
	ENDIF

	

	'Set grip target diameter (mm)
	OR_TFG_grip_addr = 33 + OR_TFG_grip_offsW 
	OR_TFG_grip_val = OR_TFG_grip_diameter*10 'Target diameter is sent as 1/10mm 


	CallProc OR_setU16(OR_TFG_grip_addr, OR_TFG_grip_val )


	'Set grip force (%)
	OR_TFG_grip_addr = 17 + OR_TFG_grip_offsW 
	OR_TFG_grip_val = OR_TFG_grip_force*10 'Force is sent as 1/10%
	CallProc OR_setU16(OR_TFG_grip_addr, OR_TFG_grip_val )
	
	
	'Control gripper according operation types
	OR_TFG_grip_addr = 1 + OR_TFG_grip_offsW
	IF OR_TFG_grip_control = 1
	SETM O[2 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	SETM O[1 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],1 'Set
	STIMER 0.1
	SETM O[2 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	ENDIF
	
	IF OR_TFG_grip_control = 2
	SETM O[2 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	SETM O[2 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],1 'Set motion stop bit
	STIMER 0.1
	SETM O[2 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	
	ELSE
	SETM O[2 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion stop bit
	SETM O[1 + OR_TFG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	ENDIF
	
	'Wait for gripper motion if needed
	IF OR_TFG_grip_wait = 1
		STIMER 0.5
		WAITJ I[17 + OR_TFG_grip_offsR + OR_FieldBUS_SB - 1]
	ENDIF


EndProc

'FUNCTION: Get Raw Diameter
'@param OR_TFG_getRawDiameter_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret OR_TFG_getRawDiaeter in mm
UsrProc OR_TFG_getDiaR( OR_TFG_getRDia_inst AS INTEGER ) AS INTEGER
	DIM OR_TFG_getRDia_addr AS INTEGER  = 0
	DIM OR_TFG_getRDia_ret AS INTEGER  = 0

	'Set bit address
	OR_TFG_getRDia_addr = 33

	'Set offset according primary (single) or secondary
	IF OR_TFG_getRDia_inst = 1
		OR_TFG_getRDia_addr = OR_TFG_getRDia_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_getRDia_addr = OR_TFG_getRDia_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_TFG_getRDia_ret = OR_getU16(OR_TFG_getRDia_addr)
	OR_TFG_getRDia_ret = OR_TFG_getRDia_ret / 10 'get mm from 1/10mm 


RetProc OR_TFG_getDiaR = OR_TFG_getRDia_ret
EndProc

'FUNCTION: Get Max Diameter
'@param OR_TFG_getMaxDia_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret getMaxDia_ret in mm
UsrProc OR_TFG_getMxD( OR_TFG_getMxD_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_getMxD_addr AS INTEGER  = 0
	DIM OR_TFG_getMxD_ret AS INTEGER  = 0

	'Set bit address
	OR_TFG_getMxD_addr = 97

	'Set offset according primary (single) or secondary
	IF  OR_TFG_getMxD_inst = 1
		OR_TFG_getMxD_addr = OR_TFG_getMxD_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_getMxD_addr = OR_TFG_getMxD_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_TFG_getMxD_ret = OR_getU16(OR_TFG_getMxD_addr)
	OR_TFG_getMxD_ret = OR_TFG_getMxD_ret / 10 'get mm from 1/10mm 

RetProc OR_TFG_getMxD = OR_TFG_getMxD_ret	
EndProc

'FUNCTION: Get Min Diameter in mm
'@param OR_TFG_getMinDia_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret OR_TFG_getMinDia_ret in mm
UsrProc OR_TFG_getMnD( OR_TFG_getMnD_inst AS INTEGER ) AS INTEGER


	DIM OR_TFG_getMnD_addr AS INTEGER = 0
	DIM OR_TFG_getMnD_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_getMnD_addr = 81

	'Set offset according primary (single) or secondary
	IF  OR_TFG_getMnD_inst = 1
		OR_TFG_getMnD_addr = OR_TFG_getMnD_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_getMnD_addr = OR_TFG_getMnD_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_TFG_getMnD_ret = OR_getU16(OR_TFG_getMnD_addr)
	OR_TFG_getMnD_ret = OR_TFG_getMnD_ret / 10 'get mm from 1/10mm 

RetProc OR_TFG_getMnD = OR_TFG_getMnD_ret	
EndProc

'FUNCTION: Set fingertip offset(mm)
'@param OR_TFG_setFT_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_TFG_setFT_radius finger radius (0-50 mm)
UsrProc OR_TFG_setFToffset(OR_TFG_setFT_inst AS INTEGER, OR_TFG_setFT_radius AS SINGLE )


  DIM OR_TFG_setFT_addr AS INTEGER = 0
  DIM OR_TFG_setFT_val AS INTEGER = 0 
  DIM OR_TFG_setFT_Pcont AS INTEGER = 0
  DIM OR_TFG_FT_Pcont_val AS INTEGER = 0
  DIM OR_TFG_setFT_offsW AS INTEGER = 0


  'Set offset according primary (single) or secondary
  IF  OR_TFG_setFT_inst = 1
    OR_TFG_setFT_offsW = OR_primW_bitOffset
  ELSE
    OR_TFG_setFT_offsW = OR_secW_bitOffset
  ENDIF

  'Set fingertip radius
  OR_TFG_setFT_addr = 81 + OR_TFG_setFT_offsW 
  OR_TFG_setFT_val = OR_TFG_setFT_radius*100 'Radius is sent as 1/100mm 
  CallProc OR_setU16(OR_TFG_setFT_addr, OR_TFG_setFT_val )

  
	'Set primary_control
	OR_TFG_setFT_Pcont = (1 + OR_TFG_setFT_offsW )
	OR_TFG_FT_Pcont_val = 102
	CallProc OR_setU16(OR_TFG_setFT_Pcont, OR_TFG_FT_Pcont_val )  'Set primary control bit
	STIMER 0.5
	OR_TFG_FT_Pcont_val = 0
	CallProc OR_setU16(OR_TFG_setFT_Pcont, OR_TFG_FT_Pcont_val )  'Set primary control bit

EndProc



'FUNCTION: Set finger length to specific length (mm)
'@param OR_TFG_setL_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_TFG_setL_length finger length (mm)
UsrProc OR_TFG_setfingerlength(OR_TFG_setL_inst AS INTEGER, OR_TFG_setL_length AS INTEGER)

	DIM OR_TFG_setL_addr AS INTEGER = 0
	DIM OR_TFG_setL_val AS INTEGER = 0
	DIM OR_TFG_setL_Pcont = 0
	DIM OR_TFG_sL_Pcont_val = 0
	DIM OR_TFG_setL_offsW AS INTEGER = 0

	'Set offset according primary (single) or secondary
	IF OR_TFG_setL_inst = 1
		OR_TFG_setL_offsW = OR_primW_bitOffset
	ELSE
		OR_TFG_setL_offsW = OR_secW_bitOffset
	ENDIF

	'Set length
	OR_TFG_setL_addr = 65 + OR_TFG_setL_offsW 
	OR_TFG_setL_val = OR_TFG_setL_length*10 'Length is sent as 1/10mm 

	CallProc OR_setU16(OR_TFG_setL_addr, OR_TFG_setL_val )

	'Set .primary_control
	OR_TFG_setL_Pcont = (1 + OR_TFG_setL_offsW )
	OR_TFG_sL_Pcont_val = 101
	CallProc OR_setU16(OR_TFG_setL_Pcont, OR_TFG_sL_Pcont_val )   'Set Finger length
	STIMER 0.5
	OR_TFG_sL_Pcont_val = 0
	CallProc OR_setU16(OR_TFG_setL_Pcont, OR_TFG_sL_Pcont_val )   'Reset primary control


EndProc


'FUNCTION: Set finger position 
'@param OR_TFG_setP_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_TFG_setP_position finger position (1-3)
UsrProc OR_TFG_setfingerPos(OR_TFG_setP_inst AS INTEGER, OR_TFG_setP_position AS INTEGER)


  DIM OR_TFG_setP_addr AS INTEGER = 0
  DIM OR_TFG_setP_val AS INTEGER = 0
  DIM OR_TFG_setP_Pcont AS INTEGER = 0
  DIM OR_TFG_sP_Pcont_val AS INTEGER = 0
  DIM OR_TFG_setP_offsW AS INTEGER = 0


  'Set offset according primary (single) or secondary
  IF  OR_TFG_setP_inst = 1
    OR_TFG_setP_offsW = OR_primW_bitOffset
  ELSE
    OR_TFG_setP_offsW = OR_secW_bitOffset
  ENDIF


  OR_TFG_setP_addr = (49 + OR_TFG_setP_offsW)
  OR_TFG_setP_val = OR_TFG_setP_position

  'Set position
  'Control gripper according operation types
  IF OR_TFG_setP_position = 1 
  CallProc OR_setU16(OR_TFG_setP_addr, OR_TFG_setP_val ) 'Finger position 1
  ENDIF
  IF OR_TFG_setP_position = 2 
   CallProc OR_setU16(OR_TFG_setP_addr, OR_TFG_setP_val )'Finger position 2
  ENDIF
  IF OR_TFG_setP_position = 3 
    CallProc OR_setU16(OR_TFG_setP_addr, OR_TFG_setP_val )'Finger position 3
  ENDIF


  IF OR_TFG_setP_position < 1 OR OR_TFG_setP_position > 3
    'Print "Invalid position value!"
    'Print "Values 1-3 are valid"
  ELSE
    'Set .primary_control
    OR_TFG_setP_Pcont = (1 + OR_TFG_setP_offsW )
	OR_TFG_sP_Pcont_val = 100
	CallProc OR_setU16(OR_TFG_setP_Pcont, OR_TFG_sP_Pcont_val )   'Set Finger position
	STIMER 0.5
	OR_TFG_sP_Pcont_val = 0
	CallProc OR_setU16(OR_TFG_setP_Pcont, OR_TFG_sP_Pcont_val )

  ENDIF

EndProc


'FUNCTION: Check gripper connection
'@param OR_TFG_isConn_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Connection state: 0=not connected, 1=connected
UsrProc OR_TFG_isConn(OR_TFG_isConn_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_isConn_addr AS INTEGER = 0
	DIM OR_TFG_isConn_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_isConn_addr = 1

	'Set offset according primary (single) or secondary
	IF OR_TFG_isConn_inst = 1
		OR_TFG_isConn_addr = OR_TFG_isConn_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_isConn_addr = OR_TFG_isConn_addr + OR_secR_bitOffset
	ENDIF

	'IF OR_TFG_isConn_inst <> 1 OR OR_TFG_isConn_inst <> 2
  	'Print "Invalid position value!"
	'Print "Only 1 or 2 is valid"
 	'ENDIF
	
	'Get data
	CallProc OR_TFG_isConn_ret = OR_getU16(OR_TFG_isConn_addr)

	IF OR_TFG_isConn_ret = 112
		OR_TFG_isConn_ret = 1
	ELSE
		OR_TFG_isConn_ret = 0
	ENDIF
RetProc OR_TFG_isConn = OR_TFG_isConn_ret
EndProc

'FUNCTION: Check that is gripper busy or idle
'@param OR_TFG_isBusy_inst Gripper instance: 1=single or primary, 2: secondary in dual configuration
'@ret Gripper state: 0=idle, 1=busy
UsrProc OR_TFG_isBusy(OR_TFG_isBusy_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_isBusy_addr AS INTEGER = 0
	DIM OR_TFG_isBusy_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_isBusy_addr = 17

	'Set offset according primary (single) or secondary
 	IF  OR_TFG_isBusy_inst = 1
   		OR_TFG_isBusy_addr = OR_TFG_isBusy_addr + OR_primR_bitOffset
 	ELSE
   		OR_TFG_isBusy_addr = OR_TFG_isBusy_addr + OR_secR_bitOffset
  	ENDIF

  	OR_TFG_isBusy_addr = OR_TFG_isBusy_addr + OR_FieldBUS_SB -1

	'Get bit status
	OR_TFG_isBusy_ret = I[OR_TFG_isBusy_addr]

RetProc OR_TFG_isBusy = OR_TFG_isBusy_ret	
EndProc

'FUNCTION: Check grip detected
'@param OR_TFG_isGrip_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Grip detected: 0=no grip, 1=grip detected
UsrProc OR_TFG_isGrip(OR_TFG_isGrip_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_isGrip_addr AS INTEGER = 0
	DIM OR_TFG_isGrip_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_isGrip_addr = 18

	'Set offset according primary (single) or secondary
	IF OR_TFG_isGrip_inst = 1
		OR_TFG_isGrip_addr = OR_TFG_isGrip_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_isGrip_addr = OR_TFG_isGrip_addr + OR_secR_bitOffset
	ENDIF

	OR_TFG_isGrip_addr = OR_TFG_isGrip_addr + OR_FieldBUS_SB -1

	'Get bit status
	OR_TFG_isGrip_ret = I[OR_TFG_isGrip_addr]

RetProc OR_TFG_isGrip = OR_TFG_isGrip_ret
EndProc

'FUNCTION: Check force grip detected
'@param OR_TFG_isFGrip_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Force Grip detected: 0=no grip, 1=grip detected
UsrProc OR_TFG_isFGrip(OR_TFG_isFGrip_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_isFGrip_addr AS INTEGER = 0
	DIM OR_TFG_isFGrip_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_isFGrip_addr = 19

	'Set offset according primary (single) or secondary
	IF OR_TFG_isFGrip_inst = 1
		OR_TFG_isFGrip_addr = OR_TFG_isFGrip_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_isFGrip_addr = OR_TFG_isFGrip_addr + OR_secR_bitOffset
	ENDIF
	
	OR_TFG_isFGrip_addr = OR_TFG_isFGrip_addr + OR_FieldBUS_SB -1

	'Get bit status
	OR_TFG_isFGrip_ret = I[OR_TFG_isFGrip_addr]

RetProc OR_TFG_isFGrip = OR_TFG_isFGrip_ret
EndProc

'FUNCTION: Calibration Valid
'@param OR_TFG_calVal_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Calibration Valid: 0=no , 1=yes
UsrProc OR_TFG_calVal(OR_TFG_calVal_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_calVal_addr AS INTEGER = 0
	DIM OR_TFG_calVal_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_calVal_addr = 20

	'Set offset according primary (single) or secondary
	IF OR_TFG_calVal_inst = 1
		OR_TFG_calVal_addr = OR_TFG_calVal_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_calVal_addr = OR_TFG_calVal_addr + OR_secR_bitOffset
	ENDIF

	OR_TFG_calVal_addr = OR_TFG_calVal_addr + OR_FieldBUS_SB -1

	'Get bit status
	OR_TFG_calVal_ret = I[OR_TFG_calVal_addr]
	
RetProc OR_TFG_calVal = OR_TFG_calVal_ret
EndProc

'FUNCTION: Check safetydcerror detected
'@param OR_TFG_safDCerr_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Safety DC error detected: 0=no error, 1=error detected
UsrProc OR_TFG_has_safetyDCerror(OR_TFG_safDCerr_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_safDCerr_addr AS INTEGER = 0
	DIM OR_TFG_safDCerr_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_safDCerr_addr = 23

	'Set offset according primary (single) or secondary
	IF OR_TFG_safDCerr_inst = 1
		OR_TFG_safDCerr_addr = OR_TFG_safDCerr_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_safDCerr_addr = OR_TFG_safDCerr_addr + OR_secR_bitOffset
	ENDIF
	
	OR_TFG_safDCerr_addr = OR_TFG_safDCerr_addr + OR_FieldBUS_SB -1

	'Get bit status
	OR_TFG_safDCerr_ret = I[OR_TFG_safDCerr_addr]
	
RetProc OR_TFG_has_safetyDCerror = OR_TFG_safDCerr_ret
EndProc


'FUNCTION: Get Diameter with Fingertip offset
'@param OR_TFG_getDiameterFT_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret OR_TFG_getDiameterFT in mm
UsrProc OR_TFG_getDiaFT( OR_TFG_getDiaFT_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_getDiaFT_addr AS INTEGER = 0
	DIM OR_TFG_getDiaFT_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_getDiaFT_addr = 49

	'Set offset according primary (single) or secondary
	IF OR_TFG_getDiaFT_inst = 1 
		OR_TFG_getDiaFT_addr = OR_TFG_getDiaFT_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_getDiaFT_addr = OR_TFG_getDiaFT_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_TFG_getDiaFT_ret = OR_getI16(OR_TFG_getDiaFT_addr)

	OR_TFG_getDiaFT_addr = OR_TFG_getDiaFT_addr
	

	IF OR_TFG_getDiaFT_addr > 0 
		CallProc OR_TFG_getDiaFT_ret = OR_getI16(OR_TFG_getDiaFT_addr)
	ENDIF

	OR_TFG_getDiaFT_ret = OR_TFG_getDiaFT_ret / 10 'get mm from 1/10mm 

RetProc OR_TFG_getDiaFT = OR_TFG_getDiaFT_ret
EndProc

'FUNCTION: Get Force
'@param OR_TFG_getForce_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret getForce in %
UsrProc OR_TFG_getForce( OR_TFG_getForce_inst AS INTEGER ) AS INTEGER

	DIM OR_TFG_getForce_addr AS INTEGER = 0
	DIM OR_TFG_getForce_ret AS INTEGER = 0

	'Set bit address
	OR_TFG_getForce_addr = 65

	'Set offset according primary (single) or secondary
	IF OR_TFG_getForce_inst = 1
		OR_TFG_getForce_addr = OR_TFG_getForce_addr + OR_primR_bitOffset
	ELSE
		OR_TFG_getForce_addr = OR_TFG_getForce_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_TFG_getForce_ret = OR_getU16(OR_TFG_getForce_addr)

	OR_TFG_getForce_ret = OR_TFG_getForce_ret / 10 'get mm from 1/10mm 

RetProc OR_TFG_getForce = OR_TFG_getForce_ret
EndProc


'FUNCTION: Stop gripper move
'@param OR_TFG_move_inst gripper instance 1 = primary(or single), 2 = secondary
UsrProc OR_TFG_Stop(OR_TFG_stop_inst AS INTEGER )

	DIM OR_TFG_stop_addr AS INTEGER = 0
	DIM OR_TFG_stop_val AS INTEGER = 0
	DIM OR_TFG_stop_offsW AS INTEGER = 0

	'Set offset according primary (single) or secondary
	IF OR_TFG_stop_inst = 1
		OR_TFG_stop_offsW = OR_primW_bitOffset
	ELSE
		OR_TFG_stop_offsW = OR_secW_bitOffset
	ENDIF

	'Start .primary_control
	OR_TFG_stop_addr = (1 + OR_TFG_stop_offsW )
	OR_TFG_stop_val = 4
	CallProc OR_setU16(OR_TFG_stop_addr, OR_TFG_stop_val )
	STIMER 0.5
	OR_TFG_stop_val = 0
	CallProc OR_setU16(OR_TFG_stop_addr, OR_TFG_stop_val )

EndProc

'FUNCTION: Screwdriver screw in
'@param OR_SD_tighten_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@param OR_SD_tighten_F force (N) 18-30
'@param OR_SD_tighten_L Screw length (mm) 0-35mm
'@param OR_SD_tighten_T torque (Nm) 0.100-5.000
'@param OR_SD_tighten_w shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_SD_tighten(OR_SD_tighten_inst AS INTEGER, OR_SD_tighten_F AS INTEGER, OR_SD_tighten_L AS INTEGER, OR_SD_tighten_T AS SINGLE, OR_SD_tighten_w AS INTEGER ) 
	DIM OR_SD_tighten_a AS INTEGER  = 0
	DIM OR_SD_tighten_v AS INTEGER  =  0
	DIM OR_SD_tighten_r AS INTEGER  =  0
	DIM OR_SD_tighten_Pcont AS INTEGER  = 0
	DIM OR_SD_tighten_offsW AS INTEGER  = 0
	DIM OR_SD_tighten_offsR AS INTEGER  = 0


	'Set offset according primary (single) or secondary
	IF OR_SD_tighten_inst = 1
		OR_SD_tighten_offsW = OR_primW_bitOffset
		OR_SD_tighten_offsR = OR_primR_bitOffset
	ELSE
		OR_SD_tighten_offsW = OR_secW_bitOffset
		OR_SD_tighten_offsR = OR_secR_bitOffset
	ENDIF
	
		'Reset control bit
	OR_SD_tighten_a = (1 + OR_SD_tighten_offsW )
	OR_SD_tighten_v = 0
	CallProc OR_setU16(OR_SD_tighten_a, OR_SD_tighten_v )

	'Set driveIn screw length (mm)
	OR_SD_tighten_a = 49 + OR_SD_tighten_offsW 
	OR_SD_tighten_v = OR_SD_tighten_L*1000 'Target diameter is sent as 1/1000mm 
	CallProc OR_setU16(OR_SD_tighten_a, OR_SD_tighten_v )

	'Set driveIn force (N)
	OR_SD_tighten_a = 33 + OR_SD_tighten_offsW 
	OR_SD_tighten_v = OR_SD_tighten_F 'Force is sent as 1/1000 N
	CallProc OR_setU16(OR_SD_tighten_a, OR_SD_tighten_v )
	
	'Set driveIn torque (Nm)
	OR_SD_tighten_a = 65 + OR_SD_tighten_offsW 
	OR_SD_tighten_v = OR_SD_tighten_T*1000 'Force is sent as 1/1000 N
	CallProc OR_setU16(OR_SD_tighten_a, OR_SD_tighten_v )
	
	STIMER 0.1
	OR_SD_tighten_a = (1 + OR_SD_tighten_offsW )
	OR_SD_tighten_v = 1
	CallProc OR_setU16(OR_SD_tighten_a, OR_SD_tighten_v )
	STIMER 0.1
	OR_SD_tighten_v = 0
	CallProc OR_setU16(OR_SD_tighten_a, OR_SD_tighten_v )
	
	'Wait for screwdriveInr motion if needed
	IF OR_SD_tighten_w = 1
		STIMER 0.5
		WAITJ I[17 + OR_SD_tighten_offsR + OR_FieldBUS_SB - 1]
		WAITJ I[18 + OR_SD_tighten_offsR + OR_FieldBUS_SB - 1]
	ENDIF

EndProc

'FUNCTION: Screwdriver drive screw out
'@param OR_SD_loosen_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_SD_loosen_F Force in N (18-30N)
'@param OR_SD_loosen_L Screw Length in mm (0-35mm)
'@param OR_SD_loosen_w shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_SD_loosen(OR_SD_loosen_inst AS INTEGER, OR_SD_loosen_F AS INTEGER, OR_SD_loosen_L AS INTEGER, OR_SD_loosen_w AS INTEGER ) 
	
	DIM OR_SD_loosen_a AS INTEGER  = 0
	DIM OR_SD_loosen_v AS INTEGER  = 0	
	DIM OR_SD_loosen_r AS INTEGER  = 0	
	DIM OR_SD_loosen_offsW AS INTEGER  = 0
	DIM OR_SD_loosen_offsR AS INTEGER  = 0

	'Set offset according primary (single) or secondary
	IF OR_SD_loosen_inst = 1
		OR_SD_loosen_offsW = OR_primW_bitOffset
		OR_SD_loosen_offsR =OR_primR_bitOffset
	ELSE
		OR_SD_loosen_offsW = OR_secW_bitOffset
		OR_SD_loosen_offsR = OR_secR_bitOffset
	ENDIF

	'Reset control bit
	OR_SD_loosen_a = (1 + OR_SD_loosen_offsW )
	OR_SD_loosen_v = 0
	CallProc OR_setU16(OR_SD_loosen_a, OR_SD_loosen_v )

	'Set drive F (N)
	OR_SD_loosen_a = 33 + OR_SD_loosen_offsW 
	OR_SD_loosen_v = OR_SD_loosen_F 'Force is sent as 1/1000 N
	CallProc OR_setU16(OR_SD_loosen_a, OR_SD_loosen_v )

	'Set drive screw length (mm)
	OR_SD_loosen_a = 49 + OR_SD_loosen_offsW 
	OR_SD_loosen_v = OR_SD_loosen_L*1000 'Target lenth is sent as 1/1000mm 
	CallProc OR_setU16(OR_SD_loosen_a, OR_SD_loosen_v )

	STIMER 0.1
	OR_SD_loosen_a = (1 + OR_SD_loosen_offsW )
	OR_SD_loosen_v = 2
	CallProc OR_setU16(OR_SD_loosen_a, OR_SD_loosen_v )
	STIMER 0.1
	OR_SD_loosen_v = 0
	CallProc OR_setU16(OR_SD_loosen_a, OR_SD_loosen_v )

	'Wait for gripper motion if needed
	IF OR_SD_loosen_w = 1
		STIMER 0.5
		WAITJ I[17 + OR_SD_loosen_offsR + OR_FieldBUS_SB - 1]
		WAITJ I[18 + OR_SD_loosen_offsR + OR_FieldBUS_SB - 1]
	ENDIF

EndProc

'FUNCTION: Pick up screw
'@param OR_SD_puScrew_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_SD_puScrew_F Force in N (18-30N)
'@param OR_SD_puScrew_L Screw Length in mm (0-35mm)
'@param OR_SD_puScrew_w shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_SD_pickupScrew(OR_SD_puScrew_inst AS INTEGER, OR_SD_puScrew_F AS INTEGER, OR_SD_puScrew_L AS INTEGER, OR_SD_puScrew_w AS INTEGER ) 
	
	DIM OR_SD_puScrew_a AS INTEGER  = 0
	DIM OR_SD_puScrew_v AS INTEGER  = 0	
	DIM OR_SD_puScrew_r AS INTEGER  = 0	
	DIM OR_SD_puScrew_offsW AS INTEGER  = 0
	DIM OR_SD_puScrew_offsR AS INTEGER  = 0

	'Set offset according primary (single) or secondary
	IF OR_SD_puScrew_inst = 1
		OR_SD_puScrew_offsW = OR_primW_bitOffset
		OR_SD_puScrew_offsR =OR_primR_bitOffset
	ELSE
		OR_SD_puScrew_offsW = OR_secW_bitOffset
		OR_SD_puScrew_offsR = OR_secR_bitOffset
	ENDIF

	'Reset control bit
	OR_SD_puScrew_a = (1 + OR_SD_puScrew_offsW )
	OR_SD_puScrew_v = 0
	CallProc OR_setU16(OR_SD_puScrew_a, OR_SD_puScrew_v )

	'Set drive F (N)
	OR_SD_puScrew_a = 33 + OR_SD_puScrew_offsW 
	OR_SD_puScrew_v = OR_SD_puScrew_F 'Force is sent as 1/1000 N
	CallProc OR_setU16(OR_SD_puScrew_a, OR_SD_puScrew_v )

	'Set drive screw Length (mm)
	OR_SD_puScrew_a = 49 + OR_SD_puScrew_offsW 
	OR_SD_puScrew_v = OR_SD_puScrew_L*1000 'Target length is sent as 1/1000mm 
	CallProc OR_setU16(OR_SD_puScrew_a, OR_SD_puScrew_v )

	'Start OR_SD_primary_control	
	STIMER 0.1
	OR_SD_puScrew_a = (1 + OR_SD_puScrew_offsW )
	OR_SD_puScrew_v = 3
	CallProc OR_setU16(OR_SD_puScrew_a, OR_SD_puScrew_v )
	STIMER 0.1
	OR_SD_puScrew_v = 0
	CallProc OR_setU16(OR_SD_puScrew_a, OR_SD_puScrew_v )


	'Wait for gripper motion if needed
	IF OR_SD_puScrew_w = 1
		STIMER 0.5
		WAITJ I[17 + OR_SD_puScrew_offsR + OR_FieldBUS_SB - 1]
		WAITJ I[18 + OR_SD_puScrew_offsR + OR_FieldBUS_SB - 1]
	ENDIF

EndProc


'FUNCTION: Set Screwdriver shank to desired position (mm)
'@param OR_SD_mvShank_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@param OR_SD_mvShank_pos set to target postion (mm) 0-55
'@param OR_SD_mvShank_w shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_SD_moveShank(OR_SD_mvShank_inst AS INTEGER, OR_SD_mvShank_pos AS INTEGER, OR_SD_mvShank_w AS INTEGER ) 
	
	DIM OR_SD_mvShank_a AS INTEGER  = 0
	DIM OR_SD_mvShank_v AS INTEGER  = 0	
	DIM OR_SD_mvShank_r AS INTEGER  = 0	
	DIM OR_SD_mS_offsW AS INTEGER  = 0
	DIM OR_SD_mS_offsR AS INTEGER  = 0
	DIM OR_SD_mS_Pcont AS INTEGER = 0
	DIM OR_SD_mS_Pcont_val AS INTEGER = 0

	'Set offset according primary (single) or secondary
	IF OR_SD_mvShank_inst = 1
		OR_SD_mS_offsW = OR_primW_bitOffset
		OR_SD_mS_offsR = OR_primR_bitOffset
	ELSE
		OR_SD_mS_offsW = OR_secW_bitOffset
	ENDIF

	'Reset control bit
	OR_SD_mS_Pcont = (1 + OR_SD_mS_offsW )
	OR_SD_mS_Pcont_val = 0
	CallProc OR_setU16(OR_SD_mS_Pcont, OR_SD_mS_Pcont_val )   'Set
		
	'Set target position
	OR_SD_mvShank_a = 17 + OR_SD_mS_offsW 
	OR_SD_mvShank_v = OR_SD_mvShank_pos 'Target position is sent as 1mm 
	CallProc OR_setU16(OR_SD_mvShank_a, OR_SD_mvShank_v )

	'Start OR_SD_mvShank primary control
	STIMER 0.1
	OR_SD_mS_Pcont = (1 + OR_SD_mS_offsW )
	OR_SD_mS_Pcont_val = 5
	CallProc OR_setU16(OR_SD_mS_Pcont, OR_SD_mS_Pcont_val )   'Set
	STIMER 0.1
	OR_SD_mS_Pcont_val = 0
	CallProc OR_setU16(OR_SD_mS_Pcont, OR_SD_mS_Pcont_val )

	'Wait for motion if needed
	IF OR_SD_mvShank_w = 1
		STIMER 0.5
		WAITJ I[18 + OR_SD_mS_offsR + OR_FieldBUS_SB - 1]
	ENDIF

EndProc

'FUNCTION: Stop Screwdriver
'@param OR_SD_stop_inst screwdriver instance 1 = primary(or single), 2 = secondary
UsrProc OR_SD_Stop(OR_SD_stop_inst AS INTEGER )

	DIM OR_SD_stop_addr AS INTEGER = 0
	DIM OR_SD_stop_val AS INTEGER = 0
	DIM OR_SD_stop_offsW AS INTEGER = 0

	'Set offset according primary (single) or secondary
	IF OR_SD_stop_inst = 1
		OR_SD_stop_offsW = OR_primW_bitOffset
	ELSE
		OR_SD_stop_offsW = OR_secW_bitOffset
	ENDIF

	'Start .primary_control
	OR_SD_stop_addr = (1 + OR_SD_stop_offsW )
	OR_SD_stop_val = 0
	STIMER 0.5
	CallProc OR_setU16(OR_SD_stop_addr, OR_SD_stop_val )
	OR_SD_stop_val = 6
	CallProc OR_setU16(OR_SD_stop_addr, OR_SD_stop_val )
	STIMER 0.5
	OR_SD_stop_val = 0
	CallProc OR_setU16(OR_SD_stop_addr, OR_SD_stop_val )

EndProc


'FUNCTION: Set Force(N) for SD
'@param OR_SD_setForce_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@param OR_SD_setForce_Newt Driver Z axis force in N, valid range: 18-30
UsrProc OR_SD_setForce(OR_SD_setForce_inst AS INTEGER, OR_SD_setForce_Newt AS INTEGER )
	
	DIM OR_SD_setForce_addr AS INTEGER = 0

	OR_SD_setForce_addr = 33

	'Shift address according primary (single) or secondary
	IF OR_SD_setForce_inst = 1
		OR_SD_setForce_addr = OR_SD_setForce_addr + OR_primW_bitOffset
	ELSE
		OR_SD_setForce_addr = OR_SD_setForce_addr + OR_secW_bitOffset
	ENDIF

	OR_SD_setForce_Newt = OR_SD_setForce_Newt*1000 ' Force sent as 1/1000 N

	'Write register
	CallProc OR_setU16(OR_SD_setForce_addr, OR_SD_setForce_Newt)

EndProc

'FUNCTION: Set Screw Length(mm) for SD
'@param OR_SD_setScrewL_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@param OR_SD_setScrewL_len Screw length in mm, valid range: 0-35
UsrProc OR_SD_setScrewL(OR_SD_setScrewL_inst AS INTEGER, OR_SD_setScrewL_len AS INTEGER )
	
	DIM OR_SD_setScrewL_addr AS INTEGER = 0

	OR_SD_setScrewL_addr = 49

	'Shift address according primary (single) or secondary
	IF OR_SD_setScrewL_inst = 1
		OR_SD_setScrewL_addr = OR_SD_setScrewL_addr + OR_primW_bitOffset
	ELSE
		OR_SD_setScrewL_addr = OR_SD_setScrewL_addr + OR_secW_bitOffset
	ENDIF

	OR_SD_setScrewL_len = OR_SD_setScrewL_len*1000 ' length sent as 1/1000 mm

	'Write register
	CallProc OR_setU16(OR_SD_setScrewL_addr, OR_SD_setScrewL_len)

EndProc

'FUNCTION: Set Torque(Nm) for SD
'@param OR_SD_setTorque_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@param OR_SD_setTorque_Tor Set driver torque in Nm, valid range: 100-5000
UsrProc OR_SD_setTorque(OR_SD_setTorque_inst AS INTEGER, OR_SD_setTorque_Tor AS INTEGER )
	
	DIM OR_SD_setTorque_addr AS INTEGER = 0

	OR_SD_setTorque_addr = 65

	'Shift address according primary (single) or secondary
	IF OR_SD_setTorque_inst = 1
		OR_SD_setTorque_addr = OR_SD_setTorque_addr + OR_primW_bitOffset
	ELSE
		OR_SD_setTorque_addr = OR_SD_setTorque_addr + OR_secW_bitOffset
	ENDIF

	OR_SD_setTorque_Tor = OR_SD_setTorque_Tor*1000 ' Torque sent as 1/1000 Nm

	'Write register
	CallProc OR_setU16(OR_SD_setTorque_addr, OR_SD_setTorque_Tor)

EndProc


'FUNCTION: Check if device connected or not
'@ret 1 = connected, 0 = not connected
UsrProc OR_SD_isConn(OR_SD_isConn_inst AS INTEGER ) AS INTEGER
	DIM OR_SD_isConn_a AS INTEGER = 0 'address
	DIM OR_SD_isConn_r AS INTEGER = 0 'return value

	'Set bit address
	OR_SD_isConn_a = 1

	'Set offset according primary (single) or secondary
	IF OR_SD_isConn_inst = 1
		OR_SD_isConn_a = OR_SD_isConn_a + OR_primR_bitOffset
	ELSE
		OR_SD_isConn_a = OR_SD_isConn_a + OR_secR_bitOffset
	ENDIF

	'Get data
	CallProc OR_SD_isConn_r = OR_getU16(OR_SD_isConn_a)
	
	IF OR_SD_isConn_r = 128
		OR_SD_isConn_r = 1
	ELSE
		OR_SD_isConn_r = 0
	ENDIF

RetProc OR_SD_isConn = OR_SD_isConn_r
EndProc

'FUNCTION: Get Busy Status
'@param OR_SD_isBusy_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret 1 = Busy, 0 = Idle
UsrProc OR_SD_isBusy(OR_SD_isBusy_inst AS INTEGER) AS INTEGER

	DIM OR_SD_isBusy_a AS INTEGER = 0
	DIM OR_SD_isBusy_r AS INTEGER = 0

	'Set bit address
	OR_SD_isBusy_a = 17

	'Set offset according primary (single) or secondary
	IF OR_SD_isBusy_inst = 1
		OR_SD_isBusy_a = OR_SD_isBusy_a + OR_primR_bitOffset
	ELSE
		OR_SD_isBusy_a = OR_SD_isBusy_a + OR_secR_bitOffset
	ENDIF
	
	'Get status
	OR_SD_isBusy_r = I[OR_SD_isBusy_a + OR_FieldBUS_SB - 1]

RetProc OR_SD_isBusy = OR_SD_isBusy_r
EndProc

'FUNCTION: Get Shank Status
'@param OR_SD_isShBusy_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret 1 = Busy, 0 = Idle
UsrProc OR_SD_isShBusy(OR_SD_isShBusy_inst AS INTEGER) AS INTEGER

	DIM OR_SD_isShBusy_a AS INTEGER = 0
	DIM OR_SD_isShBusy_r AS INTEGER = 0

	'Set bit address
	OR_SD_isShBusy_a = 18

	'Set offset according primary (single) or secondary
	IF OR_SD_isShBusy_inst = 1
		OR_SD_isShBusy_a = OR_SD_isShBusy_a + OR_primR_bitOffset
	ELSE
		OR_SD_isShBusy_a = OR_SD_isShBusy_a + OR_secR_bitOffset
	ENDIF
	
	'Get status
	OR_SD_isShBusy_r = I[OR_SD_isShBusy_a + OR_FieldBUS_SB - 1]

RetProc OR_SD_isShBusy = OR_SD_isShBusy_r
EndProc

'FUNCTION: Get Z-axis Safety Activated Error status
'@param OR_SD_SafetyEr_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret 1 = Activated, 0 = Unactivated
UsrProc OR_SD_SafetyEr(OR_SD_SafetyEr_inst AS INTEGER) AS INTEGER

	DIM OR_SD_SafetyEr_a AS INTEGER = 0
	DIM OR_SD_SafetyEr_r AS INTEGER = 0

	'Set bit address
	OR_SD_SafetyEr_a = 19

	'Set offset according primary (single) or secondary
	IF OR_SD_SafetyEr_inst = 1
		OR_SD_SafetyEr_a = OR_SD_SafetyEr_a + OR_primR_bitOffset
	ELSE
		OR_SD_SafetyEr_a = OR_SD_SafetyEr_a + OR_secR_bitOffset
	ENDIF
	
	'Get status
	OR_SD_SafetyEr_r = I[OR_SD_SafetyEr_a + OR_FieldBUS_SB - 1]

RetProc OR_SD_SafetyEr = OR_SD_SafetyEr_r
EndProc

'FUNCTION: Get Calibration Error Status
'@param OR_SD_hasCalErr_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret 1 = Error, 0 = No Error 
UsrProc OR_SD_hasCalErr(OR_SD_hasCalErr_inst AS INTEGER) AS INTEGER

	DIM OR_SD_hasCalErr_a AS INTEGER = 0
	DIM OR_SD_hasCalErr_r AS INTEGER = 0

	'Set bit address
	OR_SD_hasCalErr_a = 20

	'Set offset according primary (single) or secondary
	IF OR_SD_hasCalErr_inst = 1
		OR_SD_hasCalErr_a = OR_SD_hasCalErr_a + OR_primR_bitOffset
	ELSE
		OR_SD_hasCalErr_a = OR_SD_hasCalErr_a + OR_secR_bitOffset
	ENDIF
	
	'Get status
	OR_SD_hasCalErr_r = I[OR_SD_hasCalErr_a + OR_FieldBUS_SB - 1]

RetProc OR_SD_hasCalErr = OR_SD_hasCalErr_r
EndProc

'FUNCTION: Get Initialization Error Codes
'@param OR_SD_getinitEr_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret Status code in documentation
UsrProc OR_SD_getiniterror(OR_SD_getinitEr_inst AS INTEGER) AS INTEGER

	DIM OR_SD_getinitEr_a AS INTEGER = 0
	DIM OR_SD_getinitEr_r AS INTEGER = 0

	'Set bit address
	OR_SD_getinitEr_a = 17

	'Set offset according primary (single) or secondary
	IF OR_SD_getinitEr_inst = 1
		OR_SD_getinitEr_a = OR_SD_getinitEr_a + OR_primR_bitOffset
	ELSE
		OR_SD_getinitEr_a = OR_SD_getinitEr_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_SD_getinitEr_r = OR_getU16(OR_SD_getinitEr_a)
	IF OR_SD_getinitEr_r < 16
		OR_SD_getinitEr_r = 0
	ELSE
		'strip off addition of busy signals
		OR_SD_getinitEr_r = OR_SD_getinitEr_r ¥ 4 
		OR_SD_getinitEr_r = OR_SD_getinitEr_r * 4 
	ENDIF

RetProc OR_SD_getiniterror = OR_SD_getinitEr_r
EndProc

'FUNCTION: Get Screwdriver Force(N)
'@ret Driver Z axis force in N
'@param OR_SD_getForce_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret getForce in N
UsrProc OR_SD_getForce( OR_SD_getForce_inst AS INTEGER ) AS INTEGER

	DIM OR_SD_getForce_addr AS INTEGER = 0
	DIM OR_SD_getForce_ret AS INTEGER = 0

	'Set bit address
	OR_SD_getForce_addr = 33

	'Set offset according primary (single) or secondary
	IF OR_SD_getForce_inst = 1
		OR_SD_getForce_addr = OR_SD_getForce_addr + OR_primR_bitOffset
	ELSE
		OR_SD_getForce_addr = OR_SD_getForce_addr + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_SD_getForce_ret = OR_getU16(OR_SD_getForce_addr)
	OR_SD_getForce_ret = OR_SD_getForce_ret / 1000 'get mm from 1/1000N 

RetProc OR_SD_getForce = OR_SD_getForce_ret
EndProc

'FUNCTION: Get Screwdriver Shank Position(mm)
'@param OR_SD_getSPos_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret Screwdriver shank position in mm
UsrProc OR_SD_getShankPos( OR_SD_getSPos_inst AS INTEGER ) AS INTEGER

	DIM OR_SD_getSPos_a AS INTEGER = 0
	DIM OR_SD_getSPos_r AS INTEGER = 0

	'Set bit address
	OR_SD_getSPos_a = 49

	'Set offset according primary (single) or secondary
	IF OR_SD_getSPos_inst = 1
		OR_SD_getSPos_a = OR_SD_getSPos_a + OR_primR_bitOffset
	ELSE
		OR_SD_getSPos_a = OR_SD_getSPos_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_SD_getSPos_r = OR_getU16(OR_SD_getSPos_a)

	OR_SD_getSPos_r = OR_SD_getSPos_r / 1000 'get mm from 1/10mm 

RetProc OR_SD_getShankPos = OR_SD_getSPos_r
EndProc

'FUNCTION: Get Screwdriver Torque(Nm)
'@ret Driver torque in Nm
'@param OR_SD_getTor_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret getTorque in Nm
UsrProc OR_SD_currentTorque( OR_SD_getTor_inst AS INTEGER ) AS SINGLE

	DIM OR_SD_getTor_a AS INTEGER = 0
	DIM OR_SD_getTor_r AS SINGLE = 0.0

	'Set bit address
	OR_SD_getTor_a = 65

	'Set offset according primary (single) or secondary
	IF OR_SD_getTor_inst = 1
		OR_SD_getTor_a = OR_SD_getTor_a + OR_primR_bitOffset
	ELSE
		OR_SD_getTor_a = OR_SD_getTor_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_SD_getTor_r = OR_getU16R(OR_SD_getTor_a)

	OR_SD_getTor_r = OR_SD_getTor_r / 1000 'get Nm from 1/1000 Nm 

RetProc OR_SD_currentTorque = OR_SD_getTor_r
EndProc

'FUNCTION: Get Screwdriver Torque Gradient (Nm/RAD)
'@ret Driver torque gradient in Nm/RAD
'@param OR_SD_TorAGrd_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret OR_SD_TorAGrd_r return torque angle gradient in Nm/RAD
UsrProc OR_SD_TorqueGrd( OR_SD_TorAGrd_inst AS INTEGER ) AS INTEGER

	DIM OR_SD_TorAGrd_a AS INTEGER = 0
	DIM OR_SD_TorAGrd_r AS INTEGER = 0

	'Set bit address
	OR_SD_TorAGrd_a = 81

	'Set offset according primary (single) or secondary
	IF OR_SD_TorAGrd_inst = 1
		OR_SD_TorAGrd_a = OR_SD_TorAGrd_a + OR_primR_bitOffset
	ELSE
		OR_SD_TorAGrd_a = OR_SD_TorAGrd_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_SD_TorAGrd_r = OR_getU16(OR_SD_TorAGrd_a)

	OR_SD_TorAGrd_r = OR_SD_TorAGrd_r / 1000 'get Nm from 1/1000 Nm 

RetProc OR_SD_TorqueGrd = OR_SD_TorAGrd_r
EndProc

'FUNCTION: Get Screwdriver Achieved Torque(Nm)
'@ret Driver max achieved torque in Nm
'@param OR_SD_getMaxT_inst screwdriver instance 1 = primary(or single), 2 = secondary
'@ret getMaxTque in Nm
UsrProc OR_SD_getAchievedTor( OR_SD_getMaxT_inst AS INTEGER ) AS INTEGER

	DIM OR_SD_getMaxT_a AS INTEGER = 0
	DIM OR_SD_getMaxT_r AS INTEGER = 0

	'Set bit address
	OR_SD_getMaxT_a = 97

	'Set offset according primary (single) or secondary
	IF OR_SD_getMaxT_inst = 1
		OR_SD_getMaxT_a = OR_SD_getMaxT_a + OR_primR_bitOffset
	ELSE
		OR_SD_getMaxT_a = OR_SD_getMaxT_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_SD_getMaxT_r = OR_getU16(OR_SD_getMaxT_a)

	OR_SD_getMaxT_r = OR_SD_getMaxT_r / 1000 'get Nm from 1/1000 Nm 

RetProc OR_SD_getAchievedTor = OR_SD_getMaxT_r
EndProc

'FUNCTION: Get Command Results
'@ret Additional status code in documentation
'@param OR_SD_getCRes_inst screwdriver instance 1 = primary(or single), 2 = secondary
UsrProc OR_SD_getCommandRes(OR_SD_getCRes_inst AS INTEGER) AS INTEGER

	DIM OR_SD_getCRes_a AS INTEGER = 0
	DIM OR_SD_getCRes_r AS INTEGER = 0

	'Set bit address
	OR_SD_getCRes_a = 113

	'Set offset according primary (single) or secondary
	IF OR_SD_getCRes_inst = 1
		OR_SD_getCRes_a = OR_SD_getCRes_a + OR_primR_bitOffset
	ELSE
		OR_SD_getCRes_a = OR_SD_getCRes_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_SD_getCRes_r = OR_getU16(OR_SD_getCRes_a)

RetProc OR_SD_getCommandRes = OR_SD_getCRes_r
EndProc


'FUNCTION: Initialize soft gripper with tool id
'@param OR_SG_init_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_SG_init_toolID set SGtool grip_type
UsrProc OR_SG_Init(OR_SG_init_inst AS INTEGER, OR_SG_init_toolID AS INTEGER,  OR_SG_init_wait AS INTEGER ) AS INTEGER

	DIM OR_SG_init_addr AS INTEGER  = 0
	DIM OR_SG_init_r AS INTEGER  = 0
	DIM OR_SG_init_e AS INTEGER  = 0
	DIM OR_SG_init_val AS INTEGER  = 0
	DIM OR_SG_init_offsW AS INTEGER  = 0
	DIM OR_SG_init_offsR AS INTEGER  = 0
	DIM OR_SG_Icntr AS INTEGER = 0

'Set offset according primary (single) or secondary
	IF OR_SG_init_inst = 1
		OR_SG_init_offsW = OR_primW_bitOffset
		OR_SG_init_offsR = OR_primR_bitOffset
	ELSE
		OR_SG_init_offsW = OR_secW_bitOffset
		OR_SG_init_offsR = OR_secR_bitOffset
	ENDIF

'Set SGTool ID


	SWITCH OR_SG_init_toolID
		CASE 0
			SETM O[17 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],0 'Set
			STIMER 0.1
			BREAK
		CASE 1
			SETM O[17 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],1 'Set
			STIMER 0.1
			BREAK
		CASE 2
			SETM O[18 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],1 'Set
			STIMER 0.1
			BREAK
		CASE 3
			SETM O[17 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],1 'Set
			SETM O[18 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],1 'Set
			STIMER 0.1
			BREAK
		CASE 4
			SETM O[19 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],1 'Set
			STIMER 0.1
			BREAK
		CASE 
			SETM O[17 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],0 'Set
			BREAK

	ENDS

'Initialize gripper, and also go to home position

	SETM O[3 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],1 'Set
	SETM O[1 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],1 'Set
	STIMER 0.1
	SETM O[3 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[2 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_init_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1


	IF OR_SG_init_wait = 0
		OR_SG_init_r = 1
	ENDIF
	'If  we have to wait for the sg reach the desired width
	OR_SG_Icntr = 0
	WHILE OR_SG_init_wait
		OR_SG_Icntr = OR_SG_Icntr + 1
		STIMER 0.1

		IF I[17 + OR_SG_init_offsR + OR_FieldBUS_SB - 1] <> 1 
			OR_SG_init_wait = 0
			OR_SG_init_r = 1
		ENDIF

		IF OR_SG_Icntr > 50 'time out
			OR_SG_init_wait = 0
			PRINT #0 , "TIMEOUT WAITING FOR gripper to reach desired width"
			OR_SG_init_r = 2
		ENDIF
	ENDW
	CallProc OR_SG_init_e = OR_SG_hasErr(OR_SG_init_inst)
	IF OR_SG_init_e = 1
		OR_SG_init_r = 0
	ENDIF

RetProc OR_SG_Init = OR_SG_init_r
EndProc


'FUNCTION: Open/Close gripper to specific dictance (mm) with specific force (N)
'@param OR_SG_grip_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_SG_grip_width open/close distance (mm)
'@param OR_SG_grip_type grip type (1 or 2)
'@param OR_SG_grip_wait shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_SG_grip(OR_SG_grip_inst AS INTEGER, OR_SG_grip_width AS INTEGER, OR_SG_grip_type AS INTEGER, OR_SG_grip_wait AS INTEGER ) AS INTEGER

	DIM OR_SG_grip_a AS INTEGER = 0
	DIM OR_SG_grip_val AS INTEGER = 0
	DIM OR_SG_grip_offsW AS INTEGER = 0
	DIM OR_SG_grip_offsR AS INTEGER = 0
	DIM OR_SG_Gcntr AS INTEGER = 0
	DIM OR_SG_grip_r AS INTEGER = 0


'Set offset according primary (single) or secondary
	IF OR_SG_grip_inst = 1
		OR_SG_grip_offsW = OR_primW_bitOffset
		OR_SG_grip_offsR = OR_primR_bitOffset
	ELSE
		OR_SG_grip_offsW = OR_secW_bitOffset
		OR_SG_grip_offsR = OR_secR_bitOffset
	ENDIF

'Set width
	OR_SG_grip_a = 33 + OR_SG_grip_offsW 	
	OR_SG_grip_val = OR_SG_grip_width 				'Width is sent as mm 
	CallProc OR_setU16(OR_SG_grip_a, OR_SG_grip_val )

'Set Gentle Grip ON/OFF
	IF OR_SG_grip_type = 1
	SETM O[2 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	SETM O[1 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],1 'Set
	STIMER 0.1
	SETM O[2 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	ENDIF
	IF OR_SG_grip_type = 2
	SETM O[2 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	SETM O[2 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],1 'Set
	STIMER 0.1
	SETM O[2 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_grip_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	ENDIF

	IF OR_SG_grip_wait = 0
		OR_SG_grip_r = 1
	ENDIF
	'If  we have to wait for the sg reach the desired width
	OR_SG_Gcntr = 0
	WHILE OR_SG_grip_wait
		OR_SG_Gcntr = OR_SG_Gcntr + 1
		STIMER 0.1

		IF I[17 + OR_SG_grip_offsR + OR_FieldBUS_SB - 1] <> 1 
			OR_SG_grip_wait = 0
			OR_SG_grip_r = 1
		ENDIF

		IF OR_SG_Gcntr > 50 'time out
			OR_SG_grip_wait = 0
			PRINT #0 , "TIMEOUT WAITING FOR gripper to reach desired width"
			OR_SG_grip_r = 2
		ENDIF
	ENDW
RetProc OR_SG_grip = OR_SG_grip_r
EndProc


'FUNCTION: Release SG grip by opening
'@param OR_SG_rel_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_SG_rel_wait shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_SG_release(OR_SG_rel_inst AS INTEGER, OR_SG_rel_width AS INTEGER, OR_SG_rel_wait AS INTEGER) AS INTEGER

	DIM OR_SG_rel_a AS INTEGER  = 0
	DIM OR_SG_rel_offsW AS INTEGER  = 0
	DIM OR_SG_rel_offsR AS INTEGER  = 0
	DIM OR_SG_Rcntr AS INTEGER = 0
	DIM OR_SG_rel_r AS INTEGER = 0
	DIM OR_SG_rel_val AS INTEGER = 0

'Set offset according primary (single) or secondary
	IF OR_SG_rel_inst = 1
		OR_SG_rel_offsW = OR_primW_bitOffset
		OR_SG_rel_offsR = OR_primR_bitOffset
	ELSE
		OR_SG_rel_offsW = OR_secW_bitOffset
		OR_SG_rel_offsR = OR_secR_bitOffset
	ENDIF

'Set width
	OR_SG_rel_a = 33 + OR_SG_rel_offsW 	
	OR_SG_rel_val = OR_SG_rel_width 				'Width is sent as mm 

	CallProc OR_setU16(OR_SG_rel_a, OR_SG_rel_val )


'Release
	SETM O[2 + OR_SG_rel_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_rel_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	SETM O[2 + OR_SG_rel_offsW + OR_FieldBUS_SB - 1],1 'Set
	SETM O[1 + OR_SG_rel_offsW + OR_FieldBUS_SB - 1],1 'Set
	STIMER 0.1
	SETM O[2 + OR_SG_rel_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_rel_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit

	IF OR_SG_rel_wait = 0
		OR_SG_rel_r = 1
	ENDIF

	'If  we have to wait for the sg reach the desired width
	OR_SG_Rcntr = 0
	WHILE OR_SG_rel_wait
		OR_SG_Rcntr = OR_SG_Rcntr + 1
		STIMER 0.1
		IF I[17 + OR_SG_rel_offsR + OR_FieldBUS_SB - 1] <> 1 
			OR_SG_rel_wait = 0
			OR_SG_rel_r = 1
		ENDIF

		IF OR_SG_Rcntr > 50 'time out
			OR_SG_rel_wait = 0
			PRINT #0 , "TIMEOUT WAITING FOR gripper to reach desired width"
			OR_SG_rel_r = 2
		ENDIF
	ENDW
RetProc OR_SG_release = OR_SG_rel_r
EndProc


'FUNCTION: 
'@param OR_SG_home_inst gripper instance 1 = primary(or single), 2 = secondary
'@param OR_SG_home_wait shall we wait for command execution? 1=YES, 0=NO
UsrProc OR_SG_home(OR_SG_home_inst AS INTEGER , OR_SG_home_wait AS INTEGER ) AS INTEGER

	DIM OR_SG_home_a AS INTEGER = 0
	DIM OR_SG_home_r AS INTEGER = 0
	DIM OR_SG_home_val AS INTEGER = 0
	DIM OR_SG_home_offsW AS INTEGER = 0
	DIM OR_SG_home_offsR AS INTEGER = 0
	DIM OR_SG_Hcntr AS INTEGER = 0

'Set offset according primary (single) or secondary
	IF OR_SG_home_inst = 1
		OR_SG_home_offsW = OR_primW_bitOffset
		OR_SG_home_offsR = OR_primR_bitOffset
	ELSE
		OR_SG_home_offsW = OR_secW_bitOffset
		OR_SG_home_offsR = OR_secR_bitOffset
	ENDIF

'Release
	OR_SG_home_a =  1 + OR_SG_home_offsW  

	SETM O[2 + OR_SG_home_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_home_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	SETM O[3 + OR_SG_home_offsW + OR_FieldBUS_SB - 1],1 'Set
	SETM O[2 + OR_SG_home_offsW + OR_FieldBUS_SB - 1],1 'Set
	STIMER 0.1
	SETM O[3 + OR_SG_home_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[2 + OR_SG_home_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_home_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit

	IF OR_SG_home_wait = 0
		OR_SG_home_r = 1
	ENDIF
	'If  we have to wait for the sg reach the desired width
	OR_SG_Hcntr = 0
	WHILE OR_SG_home_wait
		OR_SG_Hcntr = OR_SG_Hcntr + 1
		STIMER 0.1
		IF I[17 + OR_SG_home_offsR + OR_FieldBUS_SB - 1] <> 1 
			OR_SG_home_wait = 0
			OR_SG_home_r = 1
		ENDIF

		IF OR_SG_Hcntr > 50 'time out
			OR_SG_home_wait = 0
			PRINT #0 , "TIMEOUT WAITING FOR gripper to reach desired width"
			OR_SG_home_r = 2
		ENDIF
	ENDW
RetProc OR_SG_home = OR_SG_home_r
EndProc


'FUNCTION: Stop gripper movement
'@param OR_SG_stop_inst gripper instance 1 = primary(or single), 2 = secondary
UsrProc OR_SG_Stop(OR_SG_stop_inst AS INTEger)

	DIM OR_SG_stop_a AS INTEGER = 0
	DIM OR_SG_stop_val AS INTEGER = 4
	DIM OR_SG_stop_offsW AS INTEGER = 0

'Set offset according primary (single) or secondary
	IF OR_SG_stop_inst = 1
		OR_SG_stop_offsW = OR_primW_bitOffset
	ELSE
		OR_SG_stop_offsW = OR_secW_bitOffset
	ENDIF

'Start .primary_control
	SETM O[3 + OR_SG_stop_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[2 + OR_SG_stop_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_stop_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	STIMER 0.1
	SETM O[3 + OR_SG_stop_offsW + OR_FieldBUS_SB - 1],1 'Set
	STIMER 0.1
	SETM O[3 + OR_SG_stop_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[2 + OR_SG_stop_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit
	SETM O[1 + OR_SG_stop_offsW + OR_FieldBUS_SB - 1],0 'Reset motion bit

EndProc


'FUNCTION: Check gripper connection
'@param OR_SG_isConn_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Connection state: 0=not connected, 1=connected
UsrProc OR_SG_isConn(OR_SG_isConn_inst AS INTEGER) AS INTEGER

	DIM OR_SG_isConn_a AS INTEGER = 0
	DIM OR_SG_isConn_r AS INTEGER = 0

	'Set bit address
	OR_SG_isConn_a = 1

	'Set offset according primary (single) or secondary
	IF OR_SG_isConn_inst = 1
		OR_SG_isConn_a = OR_SG_isConn_a + OR_primR_bitOffset
	ELSE
		OR_SG_isConn_a = OR_SG_isConn_a + OR_secR_bitOffset
	ENDIF
	
	'Get data
	CallProc OR_SG_isConn_r = OR_getU16(OR_SG_isConn_a)
	
	IF OR_SG_isConn_r = 80
		OR_SG_isConn_r = 1
	ELSE
		OR_SG_isConn_r = 0
	ENDIF
RetProc OR_SG_isConn = OR_SG_isConn_r
EndProc


'FUNCTION: Check that is gripper busy or idle
'@param OR_SG_isBusy_inst Gripper instance: 1=single or primary, 2: secondary in dual configuration
'@ret Gripper state: 0=idle, 1=busy
UsrProc OR_SG_isBusy(OR_SG_isBusy_inst AS INTEGER ) AS INTEGER

	DIM OR_SG_isBusy_a AS INTEGER = 0
	DIM OR_SG_isBusy_r AS INTEGER = 0

	'Set bit address
	OR_SG_isBusy_a = 17

	'Set offset according primary (single) or secondary
	IF OR_SG_isBusy_inst = 1
		OR_SG_isBusy_a = OR_SG_isBusy_a + OR_primR_bitOffset
	ELSE
		OR_SG_isBusy_a = OR_SG_isBusy_a + OR_secR_bitOffset
	ENDIF
	
	'Get bit status
	OR_SG_isBusy_r = I[OR_SG_isBusy_a  + OR_FieldBUS_SB - 1]
RetProc OR_SG_isBusy = OR_SG_isBusy_r
EndProc


'FUNCTION: Check that is Initialized
'@param OR_SG_isInit_inst Gripper instance: 1=single or primary, 2: secondary in dual configuration
'@ret Gripper state: 0=Uninitialized, 1=Initialized
UsrProc OR_SG_isInit(OR_SG_isInit_inst AS INTEGER) AS INTEGER

	DIM OR_SG_isInit_a AS INTEGER = 0
	DIM OR_SG_isInit_r AS INTEGER = 0

	'Set bit address
	OR_SG_isInit_a = 18

	'Set offset according primary (single) or secondary
	IF OR_SG_isInit_inst = 1
		OR_SG_isInit_a = OR_SG_isInit_a + OR_primR_bitOffset
	ELSE
		OR_SG_isInit_a = OR_SG_isInit_a + OR_secR_bitOffset
	ENDIF
	
	'Get bit status
	OR_SG_isInit_r = I[OR_SG_isInit_a + OR_FieldBUS_SB - 1]
RetProc OR_SG_isInit = OR_SG_isInit_r
EndProc


'FUNCTION: 
'@param OR_SG_hasErr_inst Gripper instance: 1=single or primary, 2: secondary in dual configuration
'@ret Gripper state: 0=idle, 1=busy
UsrProc OR_SG_hasErr(OR_SG_hasErr_inst AS INTEGER) AS INTEGER

	DIM OR_SG_hasErr_a AS INTEGER = 0
	DIM OR_SG_hasErr_r AS INTEGER = 0
	DIM OR_SG_hasErr_val AS INTEGER = 0

	'Set bit address
	OR_SG_hasErr_a = 17

	'Set offset according primary (single) or secondary
	IF OR_SG_hasErr_inst = 1
		OR_SG_hasErr_a = OR_SG_hasErr_a + OR_primR_bitOffset
	ELSE
		OR_SG_hasErr_a = OR_SG_hasErr_a + OR_secR_bitOffset
	ENDIF
	
	CallProc OR_SG_hasErr_val = OR_getU16(OR_SG_hasErr_a)

	IF OR_SG_hasErr_val > 15
		OR_SG_hasErr_r = 1
	ELSE
		OR_SG_hasErr_r = 0
	ENDIF

RetProc OR_SG_hasErr = OR_SG_hasErr_r
EndProc


'FUNCTION: Get gripper actual width (mm)
'@param OR_SG_getWid_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Actual width in mm
UsrProc OR_SG_getWid(OR_SG_getWid_inst AS INTEGER) AS INTEGER

	DIM OR_SG_getWid_r AS INTEGER = 0 'return value
	DIM OR_SG_getWid_a AS INTEGER = 0 'address
	
	'Set bit address
	OR_SG_getWid_a = 81

	'Set offset, primary or secondary 
	IF OR_SG_getWid_inst = 1
		OR_SG_getWid_a = OR_SG_getWid_a + OR_primR_bitOffset
	ELSE
		OR_SG_getWid_a = OR_SG_getWid_a + OR_secR_bitOffset
	ENDIF

	'Get Data
	CallProc OR_SG_getWid_r = OR_getU16(OR_SG_getWid_a)

	IF OR_SG_getWid_r >= 32768
		OR_SG_getWid_r = OR_SG_getWid_r - 65536
	ENDIF

RetProc OR_SG_getWid = OR_SG_getWid_r
EndProc


'FUNCTION: Get gripper Maximum width (mm)
'@param OR_SG_getMaxWid_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Actual width in mm
UsrProc OR_SG_getMaxWid(OR_SG_getMaxWid_inst AS INTEGER) AS INTEGER

	DIM OR_SG_getMaxWid_r AS INTEGER = 0 'return value
	DIM OR_SG_getMaxWid_a AS INTEGER = 0 'address
	
	'Set bit address
	OR_SG_getMaxWid_a = 97

	'Set offset, primary or secondary
	IF OR_SG_getMaxWid_inst = 1
		OR_SG_getMaxWid_a = OR_SG_getMaxWid_a + OR_primR_bitOffset
	ELSE
		OR_SG_getMaxWid_a = OR_SG_getMaxWid_a + OR_secR_bitOffset
	ENDIF

	'Get Data
	CallProc OR_SG_getMaxWid_r = OR_getU16(OR_SG_getMaxWid_a)

RetProc OR_SG_getMaxWid = OR_SG_getMaxWid_r
EndProc


'FUNCTION: Get gripper Minimum width (mm)
'@param OR_SG_getMinWid_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Actual width in mm
UsrProc OR_SG_getMinWid(OR_SG_getMinWid_inst AS INTEGER) AS INTEGER

	DIM OR_SG_getMinWid_r AS INTEGER = 0 'return value
	DIM OR_SG_getMinWid_a AS INTEGER = 0 'address
	
	'Set bit address
	OR_SG_getMinWid_a = 113

	'Set offset, primary or secondary
	IF OR_SG_getMinWid_inst = 1
		OR_SG_getMinWid_a = OR_SG_getMinWid_a + OR_primR_bitOffset
	ELSE
		OR_SG_getMinWid_a = OR_SG_getMinWid_a + OR_secR_bitOffset
	ENDIF

	CallProc OR_SG_getMinWid_r = OR_getU16(OR_SG_getMinWid_a)

RetProc OR_SG_getMinWid = OR_SG_getMinWid_r
EndProc


'FUNCTION: Get depth of tool
'@param OR_SG_getDep_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Depth of tool in mm
UsrProc OR_SG_getDep(OR_SG_getDep_inst AS INTEGER ) AS INTEGER

	DIM OR_SG_getDep_r AS INTEGER = 0 'return value
	DIM OR_SG_getDep_a AS INTEGER = 0 'address

	'Set bit address
	OR_SG_getDep_a = 33

	'Set offset, primary or secondary 
	IF OR_SG_getDep_inst = 1
		OR_SG_getDep_a = OR_SG_getDep_a + OR_primR_bitOffset
	ELSE 
		OR_SG_getDep_a = OR_SG_getDep_a + OR_secR_bitOffset
	ENDIF

	'Get data
	CallProc OR_SG_getDep_r = OR_getU16(OR_SG_getDep_a)

RetProc OR_SG_getDep = OR_SG_getDep_r
EndProc


'FUNCTION: Get relative depth of tool
'@param OR_SG_getRelDep_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret Relative depth of tool after gripping
UsrProc OR_SG_getRelDep(OR_SG_getRelDep_inst AS INTEGER) AS INTEGER

	DIM OR_SG_getRelDep_r AS INTEGER = 0 'return value
	DIM OR_SG_getRelDep_a AS INTEGER = 0 'address

	'Set bit address
	OR_SG_getRelDep_a = 49

	'Set offset, primary or secondary 
	IF OR_SG_getRelDep_inst = 1
		OR_SG_getRelDep_a = OR_SG_getRelDep_a + OR_primR_bitOffset
	ELSE 
		OR_SG_getRelDep_a = OR_SG_getRelDep_a + OR_secR_bitOffset
	ENDIF

	'Get data
	CallProc OR_SG_getRelDep_r = OR_getU16(OR_SG_getRelDep_a)
	OR_SG_getRelDep_r = OR_SG_getRelDep_r/10 'to mm

RetProc OR_SG_getRelDep = OR_SG_getRelDep_r
EndProc


'FUNCTION: Get depth of silicone tool
'@param OR_SG_getSilDep_inst gripper instance 1 = primary(or single), 2 = secondary
'@ret 
UsrProc OR_SG_getSilDep(OR_SG_getSilDep_inst AS INTEGER ) AS INTEGER 

	DIM OR_SG_getSilDep_r AS INTEGER = 0 'return value
	DIM OR_SG_getSilDep_a AS INTEGER = 0 'address

	'Set bit address
	OR_SG_getSilDep_a = 65

	'Set offset, primary or secondary 
	IF OR_SG_getSilDep_inst = 1
		OR_SG_getSilDep_a = OR_SG_getSilDep_a + OR_primR_bitOffset
	ELSE 
		OR_SG_getSilDep_a = OR_SG_getSilDep_a + OR_secR_bitOffset
	ENDIF

	'Get data
	CallProc OR_SG_getSilDep_r = OR_getU16(OR_SG_getSilDep_a)
	OR_SG_getSilDep_r = OR_SG_getSilDep_r/10 'to mm

RetProc OR_SG_getSilDep = OR_SG_getSilDep_r
EndProc

'FUNCTION: Set uint16 value to output according the OnRobot regsiter address'
'@param OR_setU16_SB starting bit (address) according OnRobot register map'
'@param OR_setU16_val uint16 value (for Real numbers)'
UsrProc OR_setU16R(OR_setU16R_SB As INTEGER, OR_setU16R_val AS SINGLE )
  OR_setU16R_SB = OR_setU16R_SB+OR_FieldBUS_SB-1

  FOR L1%=0 TO 15 STEP 1
    IF(OR_setU16R_val mod 2 >= 1)
      SET O[OR_setU16R_SB + L1%]
    ELSE
      RESET O[OR_setU16R_SB + L1%]
    ENDIF
    OR_setU16R_val = OR_setU16R_val / 2
  NEXT
  INH
EndProc

'FUNCTION: Get int16 value from input according the OnRobot regsiter address
'@param OR_getI16_SB starting bit (address) according OnRobot register map
UsrProc OR_getI16R(OR_getI16R_SB AS INTEGER) AS SINGLE
	DIM OR_getI16R_ret AS SINGLE = 0.0

	OR_getI16R_SB = (OR_getI16R_SB -1 + OR_FieldBUS_SB - 1 )/8 + 4
	OR_getI16R_ret   = GETSIGB(OR_getI16R_SB,0)+2^8 * GETSIGB(OR_getI16R_SB+1,0)

	IF OR_getI16R_ret  >= 32768
		OR_getI16R_ret  = OR_getI16R_ret - 65536
	ENDIF

RetProc OR_getI16R = OR_getI16R_ret 
EndProc

'FUNCTION: Get uint16 value from input according the OnRobot regsiter address
'@param OR_getU16R_SB starting bit (address) according OnRobot register map
UsrProc OR_getU16R(OR_getU16R_SB AS INTEGER) AS SINGLE
	DIM OR_getU16R_ret AS SINGLE = 0.0

	OR_getU16R_SB = (OR_getU16R_SB -1 + OR_FieldBUS_SB - 1 )/8 + 4
	OR_getU16R_ret  = GETSIGB(OR_getU16R_SB,0)+2^8 * GETSIGB(OR_getU16R_SB+1,0)

RetProc OR_getU16R = OR_getU16R_ret
EndProc

'FUNCTION: Check if device connected or not'
'@ret 1 = connected, 0 = not connected'
UsrProc OR_EYES_isConn(EYES_isConn_inst AS INTEGER) AS INTEGER
  
  DIM EYES_isConn_a AS INTEGER = 0 'address'
  DIM EYES_isConn_r AS INTEGER = 0 'return value'

  'Set bit address'
  EYES_isConn_a = 1
  IF EYES_isConn_inst = 1
    EYES_isConn_a = EYES_isConn_a + OR_EYESrOffset
  ELSE
    EYES_isConn_a = EYES_isConn_a + OR_EYESrOffset
  ENDIF

  'Get data'
  CallProc EYES_isConn_r = OR_getU16(EYES_isConn_a)

'Set return value
  IF EYES_isConn_r = 96
    EYES_isConn_r = 1
  ELSE
    EYES_isConn_r = 0
  ENDIF

RetProc  OR_EYES_isConn = EYES_isConn_r
EndProc

'FUNCTION: Sends robot pose to Eye Box for external mount calibration'
UsrProc OR_EYES_calibrate()
'Use robot pose file 1'
  USE 1

    DIM EYES_cal_ctrl AS INTEGER = 0
    DIM EYES_cal_addr AS INTEGER = 0
    DIM EYES_robot_a AS INTEGER = 0
    DIM EYES_robot_type AS INTEGER = 0
    DIM EYES_pose_a AS INTEGER = 0
    DIM EYES_posHolder AS SINGLE = 0
    DIM EYES_robotPose AS POSITION
    DIM EYES_tempPose[7] AS SINGLE

    'Set Control - Set to 0 to reset control'
    EYES_cal_ctrl = 0
    EYES_cal_addr = 1
    CallProc OR_setU16( EYES_cal_addr, EYES_cal_ctrl )

    'Wait for control to reset'
    STIMER 0.1
   
    'Get current robot position'
    GETPOS 1, 1, EYES_robotPose, 0, 1
    OPEPOS 1, EYES_robotPose, EYES_tempPose[1], 0, 0
    
    'Send current robot position'
    FOR L1% = 1 TO 6 STEP 1
      IF L1% < 4
        EYES_tempPose[L1%] = EYES_tempPose[L1%] * 10
      ELSE
        EYES_tempPose[L1%]  = EYES_tempPose[L1%] * 100
      ENDIF
      IF  EYES_tempPose[L1%] < 0
        EYES_tempPose[L1%] = EYES_tempPose[L1%] + 65536
      ENDIF
      EYES_pose_a = 65 + ((L1% - 1) * 16)
      CallProc OR_setU16R(EYES_pose_a, EYES_tempPose[L1%])
    NEXT
    
    'Set Robot Type'
    EYES_robot_a = 33 
    EYES_robot_type = 5 ' OR_EYE Nachi = 5'
    CallProc OR_setU16(EYES_robot_a, EYES_robot_type )
    
    'Set Control - Set to 2 to send calibration pose'
    EYES_cal_ctrl = 2
    EYES_cal_addr = 1
    CallProc OR_setU16(EYES_cal_addr, EYES_cal_ctrl )

'Save robot pose to pose file'
  POS2POSE 1, EYES_robotPose, 0, 1, P2
  POSESAVE

EndProc

'FUNCTION: Runs program, returns object count'
'@param EYES_locate_prog_ID, Compute box will display ID, input this integer'
UsrProc OR_EYES_Locate(EYES_prog_ID AS INTEGER) AS INTEGER
'Using robot pose file 1'
  USE 1
'Primary function variables'
  DIM EYES_locate_type AS INTEGER = 5 ' OR_EYES_Nachi = 5'
  DIM EYES_locate_a AS INTEGER = 0
  DIM EYES_locate_val AS INTEGER = 0
  DIM EYES_locate_ctrl AS INTEGER = 0
 
'Counter variables'
  DIM EYES_runcnt_val AS INTEGER = 0
  DIM EYES_runcnt_addr AS INTEGER = 0
 
'robot model type variables'
  DIM EYES_rbt_a AS INTEGER = 0
  DIM EYES_rbt_type AS INTEGER = 0
 
'Robot position variables'
  DIM EYES_gripper_a AS INTEGER = 0
  DIM EYES_rbtPose AS POSITION
  DIM EYES_tmpPose[7] AS SINGLE
  DIM EYES_rPose_a AS INTEGER = 0
  DIM EYES_runcntNow_v AS INTEGER = 0
  DIM EYES_exitcount AS INTEGER = 0
  DIM EYES_exitcondition AS INTEGER = 0
 
'Error and output variables'
  DIM EYES_err_bitOffset AS INTEGER = 0
  DIM EYES_err_a AS INTEGER = 0
  DIM EYES_err_v AS INTEGER = 0
  DIM EYES_objCount_r AS INTEGER = 0
  DIM EYES_objCount_a AS INTEGER = 0

'Set Control - Set to 0 to reset run program'
  EYES_locate_ctrl = 0
  EYES_locate_a = 1 
  EYES_locate_val = EYES_locate_ctrl
  CallProc OR_setU16(EYES_locate_a, EYES_locate_val)

'Wait for control to reset'
  STIMER 0.1
  
'Get current value of runCounter variable'
'Counter value is stored in first 2 bits of the adress range, modulus operator allows returning only that portion of the value'
  EYES_runcnt_val = 0
  EYES_runcnt_addr = 17
  CallProc EYES_runcnt_val = OR_getU16(EYES_runcnt_addr)
  EYES_runcnt_val = EYES_runcnt_val MOD 4

'Set Program ID'
  EYES_locate_a = 17
  EYES_locate_val = EYES_prog_ID
  CallProc OR_setU16(EYES_locate_a, EYES_locate_val )
  
'Set Robot Type'
  EYES_rbt_a = 33 
  EYES_rbt_type = 5 ' OR_EYE Nachi = 5'
  CallProc OR_setU16(EYES_rbt_a, EYES_rbt_type )
  
'Get current robot position and store in an array'
    GETPOS 1, 1, EYES_rbtPose, 0, 1
    OPEPOS 1, EYES_rbtPose, EYES_tmpPose[1], 0, 0 
'Send robot position to the EYEBOX from array'
    FOR L2% = 1 TO 6 STEP 1
      IF L2% < 4
        EYES_tmpPose[L2%] = EYES_tmpPose[L2%] * 10
      ELSE
        EYES_tmpPose[L2%]  = EYES_tmpPose[L2%] * 100
      ENDIF
      IF  EYES_tmpPose[L2%] < 0
        EYES_tmpPose[L2%] = EYES_tmpPose[L2%] + 65536
      ENDIF
      EYES_rPose_a = 65 + ((L2% -1) * 16)
      CallProc OR_setU16R(EYES_rPose_a, EYES_tmpPose[L2%])
    NEXT

'Set Control - Set to 1 to run program'
  EYES_locate_ctrl = 1
  EYES_locate_a = 1 
  EYES_locate_val = EYES_locate_ctrl
  CallProc OR_setU16(EYES_locate_a, EYES_locate_val )

'While loop to check runcounter'
'Exit if value has changed or 3s (30 * 0.1s wait) has passed'
  EYES_runcntNow_v = EYES_runcnt_val
  EYES_exitcount = 0
  EYES_exitcondition = 30
'Get current counter value'
'Counter value is stored in first 2 bits of the adress range, modulus operation returns only the value of those bits 
  WHILE (EYES_runcntNow_v = EYES_runcnt_val) AND (EYES_exitcount < EYES_exitcondition)
    CallProc EYES_runcntNow_v = OR_getU16(EYES_runcnt_addr)
	EYES_runcntNow_v = EYES_runcntNow_v MOD 4
    EYES_exitcount = EYES_exitcount + 1
    STIMER 0.1
  ENDW
  
'Check the error bit'
'Return -1 for error or number of objects found'
  EYES_err_bitOffset = 2
  EYES_err_a = 17  + EYES_err_bitOffset
  EYES_err_v = I[EYES_err_a]
  IF EYES_err_v = 1 OR EYES_exitcount = EYES_exitcondition
    EYES_objCount_r = -1
  ELSE
'Get object count'
    EYES_objCount_a = 33
    CallProc EYES_objCount_r = OR_getU16(EYES_objCount_a)
  ENDIF

'Save robot pose data to pose file'
	POS2POSE 1, EYES_rbtPose, 0, 1, P3
	POSESAVE
'Return object count'
RetProc OR_EYES_Locate = EYES_objCount_r
EndProc

UsrProc OR_EYES_getObjPos(EYES_gripper_inst AS INTEGER ) 
'@param EYESEYES_gripper_inst, gripper instance 0 = none, 1 = primary, 2 = secondary, 3 = single'
'Use robot pose file 1'
  USE 1

  DIM EYES_get_r AS SINGLE = 0 
  DIM EYES_get_a AS INTEGER = 0 
  DIM temp_pose[7] AS SINGLE
  DIM EYES_object_pose AS POSITION
  DIM EYES_runcntr_val AS INTEGER = 0
  DIM EYES_runcntr_addr AS INTEGER = 0
  DIM EYES_gripper_addr AS INTEGER = 0
  DIM EYES_getObj_control AS INTEGER = 0
  DIM EYES_getObj_addr AS INTEGER = 0
  DIM EYES_getObj_val AS INTEGER = 0
  DIM EYES_runcntrNow_val AS INTEGER = 0
  DIM EYES_exitcounter AS INTEGER = 0
  DIM EYES_exitcon AS INTEGER = 0

'Get current value of runCounter variable'
  EYES_runcntr_val = 0
  EYES_runcntr_addr = 17
  CallProc EYES_runcntr_val = OR_getU16(EYES_runcntr_addr)
  EYES_runcntr_val = EYES_runcntr_val MOD 4
  
'Set Gripper Inst'
  EYES_gripper_addr = 49
  CallProc OR_setU16(EYES_gripper_addr, EYES_gripper_inst)

'Set Control - Set to 3 to get objectPose'
  EYES_getObj_control = 3
  EYES_getObj_addr = 1
  EYES_getObj_val = EYES_getObj_control
  CallProc OR_setU16(EYES_getObj_addr, EYES_getObj_val)
  
'While loop to check runcounter'
'Exit if value has changed or 3s (30 * 0.1s wait) has passed'
  EYES_runcntrNow_val = EYES_runcntr_val
  EYES_exitcounter = 0
  EYES_exitcon = 30
'Get current counter value'
'Counter value is stored in first 2 bits of the adress range, modulus operation returns only the value of those bits'
  WHILE (EYES_runcntrNow_val = EYES_runcntr_val) AND (EYES_exitcounter < EYES_exitcon)
    CallProc EYES_runcntrNow_val = OR_getU16(EYES_runcntr_addr)
    EYES_runcntrNow_val = EYES_runcntrNow_val MOD 4
    EYES_exitcounter = EYES_exitcounter + 1
    STIMER 0.1
  ENDW

'Get object position from the compute box, stored in an array'  
  FOR L3% = 1 TO 6 STEP 1
  EYES_get_a = 49 + ((L3% - 1) * 16)
    CallProc EYES_get_r = OR_getI16R(EYES_get_a )
    IF L3% < 4
      temp_pose[L3%] = EYES_get_r/10
    ELSE
      temp_pose[L3%]  = EYES_get_r/100
    ENDIF
  NEXT
'Write the array to the position variable'
    OPEPOS 1, EYES_object_pose, temp_pose[1], 0, 1
'Save object position to pose file'
  POS2POSE 1, EYES_object_pose, 0, 1, P4
  POSESAVE

EndProc

'FUNCTION: Returns the model type of the last object position sent'
'@return the model type (as an integer) corresponding the the program setup by the user'
UsrProc OR_EYES_getModelType() AS INTEGER

  DIM EYES_modelType_a AS INTEGER = 0 'address'
  DIM EYES_modelType_r AS INTEGER = 0 'return value'
  DIM EYES_Type_bitOffset AS INTEGER = 0 'return value'
  DIM EYES_Type_numBits AS INTEGER = 0 'return value'

'Set bit address'
  EYES_modelType_a = 17
  
'Get data from address, starting at bit 4, modulus operation removes first 3 bits, division scales down by the bits removed (2^3)'
  CallProc EYES_modelType_r = OR_getU16(EYES_modelType_a)
  WHILE EYES_modelType_r MOD 8 <> 0
    EYES_modelType_r = EYES_modelType_r - 1
  ENDW
  EYES_modelType_r = EYES_modelType_r / 8
'Return model type'
RetProc OR_EYES_getModelType = EYES_modelType_r
EndProc

